Package: BiocSingular
Version: 1.28.0
Date: 2025-10-23
Title: Singular Value Decomposition for Bioconductor Packages
Authors@R: c(person("Aaron", "Lun", role=c("aut", "cre", "cph"),
        email="infinite.monkeys.with.keyboards@gmail.com"))
Imports: BiocGenerics, S4Vectors, Matrix, methods, utils, DelayedArray,
        BiocParallel, ScaledMatrix, irlba, rsvd, Rcpp, beachmat (>=
        2.25.1)
Suggests: testthat, BiocStyle, knitr, rmarkdown, ResidualMatrix
biocViews: Software, DimensionReduction, PrincipalComponent
Description: Implements exact and approximate methods for singular value
        decomposition and principal components analysis, in a framework that
        allows them to be easily switched within Bioconductor packages or 
        workflows. Where possible, parallelization is achieved using 
        the BiocParallel framework.
License: GPL-3
LinkingTo: Rcpp, beachmat, assorthead
VignetteBuilder: knitr
SystemRequirements: C++17
RoxygenNote: 7.3.3
Encoding: UTF-8
BugReports: https://github.com/LTLA/BiocSingular/issues
URL: https://github.com/LTLA/BiocSingular
git_url: https://git.bioconductor.org/packages/BiocSingular
git_branch: RELEASE_3_23
git_last_commit: 675ff54
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.23
Date/Publication: 2026-04-28
NeedsCompilation: yes
Packaged: 2026-04-28 20:54:02 UTC; biocbuild
Author: Aaron Lun [aut, cre, cph]
Maintainer: Aaron Lun <infinite.monkeys.with.keyboards@gmail.com>

# Singular value decomposition for Bioconductor

|Build|Status|
|-----|----|
| Bioc-release | [![](https://bioconductor.org/shields/build/release/bioc/BiocSingular.svg)](https://bioconductor.org/checkResults/release/bioc-LATEST/BiocSingular) |
| Bioc-devel   | [![](https://bioconductor.org/shields/build/devel/bioc/BiocSingular.svg)](https://bioconductor.org/checkResults/devel/bioc-LATEST/BiocSingular) | 

This package provides a consistent class interface for singular value decompositions and principal components analysis for use throughout the Bioconductor ecosystem.
Check out the user guide on the [Bioconductor landing page](https://bioconductor.org/packages/devel/bioc/html/BiocSingular.html) for more details.

check_numbers <- function(x, k, nv, nu, limit=min(dim(x))) 
# Sanity checks for 'k', 'nv' and 'nu'.
{
    if (k < 0 || nv < 0 || nu < 0) {
        stop("number of requested singular values/vectors must be non-negative")
    }

    if (is.infinite(k)) { 
        k <- limit
    }
    if (is.infinite(nv)) {
        nv <- limit
    }
    if (is.infinite(nu)) {
        nu <- limit
    }

    if (max(k, nu, nv) > limit) {
        warning("more singular values/vectors requested than available")
        k <- min(limit, k)
        nv <- min(limit, nv)
        nu <- min(limit, nu)
    }
    
    list(k=k, nv=nv, nu=nu)
}

#' @importFrom BiocParallel SerialParam
#' @importFrom utils head
#' @importFrom BiocGenerics nrow ncol
#' @importFrom Matrix crossprod tcrossprod
#' @importFrom DelayedArray sweep
svd_via_crossprod <- function(x, k, nu=k, nv=k, FUN=svd, ...) 
# Computes the SVD via a crossproduct, using 'FUN' with arguments '...'. 
# We assume that any centering/scaling has already been applied to 'x'.
{
    if (nrow(x) > ncol(x)) {
        y <- as.matrix(crossprod(x))
        res <- FUN(y, nu=0, nv=max(nu, nv, k), ...)
        res$d <- sqrt(res$d)

        u0 <- x %*% res$v[,seq_len(nu),drop=FALSE]
        res$u <- sweep(u0, 2, head(res$d, nu), "/")
        res$v <- as.matrix(res$v[,seq_len(nv),drop=FALSE])

    } else {
        y <- as.matrix(tcrossprod(x))
        res <- FUN(y, nu=max(nu, nv, k), nv=0, ...)
        res$d <- sqrt(res$d)

        v0 <- crossprod(x, res$u[,seq_len(nv),drop=FALSE])
        res$v <- sweep(v0, 2, head(res$d, nv), "/")
        res$u <- as.matrix(res$u[,seq_len(nu),drop=FALSE])
    }

    res$d <- head(res$d, k)
    standardize_output_SVD(res, x)
}

#' @importFrom BiocGenerics nrow ncol
use_crossprod <- function(x, fold) {
    if (any(dim(x)==0L)) { # avoid problems when 'fold=Inf'.
        FALSE
    } else {
        nrow(x) >= fold*ncol(x) || ncol(x) >= nrow(x)*fold
    }
}

#' @export
setMethod("runPCA", "ANY", function(x, rank, center=TRUE, scale=FALSE, get.rotation=TRUE, get.pcs=TRUE, ...) 
# Converts SVD results to PCA results.
{
    svd.out <- runSVD(x, k=rank, 
        nu=ifelse(get.pcs, rank, 0),
        nv=ifelse(get.rotation, rank, 0),
        center=center, scale=scale, ...)

    # Not naming sdev for consistency with prcomp().
    out <- list(sdev=svd.out$d / sqrt(nrow(x) - 1))

    NAMEFUN <- function(n) sprintf("PC%i", seq_len(n))

    if (get.rotation) {
        out$rotation <- svd.out$v
        colnames(out$rotation) <- NAMEFUN(ncol(out$rotation))
    } 
    if (get.pcs) {
        out$x <- sweep(svd.out$u, 2, svd.out$d, "*")
        colnames(out$x) <- NAMEFUN(ncol(out$x))
    }

    out
})

# BiocSingular matrix class for a reconstructed low-rank matrix.
# Useful for representing the low-rank matrix without actually making it.

###################################
###################################
###################################
# Constructing the seed.

#' @export
#' @importFrom methods new is
LowRankMatrixSeed <- function(rotation, components) {
    if (missing(rotation)) {
        if (missing(components)) {
            rotation <- components <- matrix(0, 0, 0)
        } else {
            rotation <- matrix(0, 0, ncol(components))
        }
    } else if (is(rotation, "LowRankMatrixSeed")) {
        return(rotation) # directly returning the seed already.
    } else if (missing(components)) {
        components <- matrix(0, 0, ncol(rotation))
    }

    new("LowRankMatrixSeed", rotation=rotation, components=components)
}

#' @importFrom S4Vectors setValidity2
setValidity2("LowRankMatrixSeed", function(object) {
    msg <- character(0)

    R <- get_rotation(object)
    C <- get_components(object)

    if (length(dim(R))!=2L || length(dim(C))!=2L) {
        msg <- c(msg, "'components' and 'rotation' must be matrix-like objects")
    } else if (ncol(R) != ncol(C)) {
        msg <- c(msg, "number of columns in 'components' and 'rotation' must be the same");
    }

    if (length(msg)) {
        return(msg)
    } 
    return(TRUE)
})

#' @export
#' @importFrom methods show
setMethod("show", "LowRankMatrixSeed", function(object) {
    cat(sprintf("%i x %i LowRankMatrixSeed object", nrow(object), ncol(object)),
    sep="\n")
})

###################################
# Internal getters.

get_rotation <- function(x) x@rotation

get_components <- function(x) x@components

###################################
# DelayedArray support utilities. 

#' @export
setMethod("dim", "LowRankMatrixSeed", function(x) {
    c(nrow(get_rotation(x)), nrow(get_components(x)))
})

#' @export
setMethod("dimnames", "LowRankMatrixSeed", function(x) {
    list(rownames(get_rotation(x)), rownames(get_components(x)))
})

#' @export
#' @importFrom DelayedArray extract_array
#' @importFrom Matrix tcrossprod
setMethod("extract_array", "LowRankMatrixSeed", function(x, index) {
	x2 <- subset_LowRankMatrixSeed(x, index[[1]], index[[2]])
    as.matrix(tcrossprod(get_rotation(x2), get_components(x2)))
})

###################################
# Additional utilities for efficiency.

subset_LowRankMatrixSeed <- function(x, i, j) {
    C <- get_components(x)
    R <- get_rotation(x)

    if (!is.null(i)) {
        R <- R[i,,drop=FALSE]
    }
    
    if (!is.null(j)) {
        C <- C[j,,drop=FALSE]
    }

    LowRankMatrixSeed(R, C)
}

transpose_LowRankMatrixSeed <- function(x) {
    C <- get_components(x)
    R <- get_rotation(x)
    LowRankMatrixSeed(C, R)
}

rename_LowRankMatrixSeed <- function(x, value) {
    R <- get_rotation(x)
    rownames(R) <- value[[1]]
    C <- get_components(x)
    rownames(C) <- value[[2]]
    LowRankMatrixSeed(R, C)
}

###################################
###################################
###################################
# Constructing the matrix.

#' @export
#' @importFrom DelayedArray DelayedArray
LowRankMatrix <- function(rotation, components) {
    DelayedArray(LowRankMatrixSeed(rotation, components))
}

#' @export
#' @importFrom DelayedArray DelayedArray new_DelayedArray
setMethod("DelayedArray", "LowRankMatrixSeed",
    function(seed) new_DelayedArray(seed, Class="LowRankMatrix")
)

###################################
# Overridden utilities from DelayedArray, for efficiency.

#' @export
#' @importFrom DelayedArray DelayedArray seed
setReplaceMethod("dimnames", "LowRankMatrix", function(x, value) {
    DelayedArray(rename_LowRankMatrixSeed(seed(x), value))
})

#' @export
#' @importFrom Matrix t
#' @importFrom DelayedArray DelayedArray seed
setMethod("t", "LowRankMatrix", function(x) {
    DelayedArray(transpose_LowRankMatrixSeed(seed(x)))
})

#' @export
#' @importFrom DelayedArray DelayedArray seed drop
setMethod("[", "LowRankMatrix", function(x, i, j, ..., drop=TRUE) {
    if (missing(i)) i <- NULL
    if (missing(j)) j <- NULL
    out <- DelayedArray(subset_LowRankMatrixSeed(seed(x), i=i, j=j))

    if (drop && any(dim(out)==1L)) {
        return(drop(out))
    }
    out
})

# Tests the LowRankMatrix implementation.
# library(testthat); library(BiocSingular); source("test-lowrank.R")

spawn_scenarios <- function(NR=50, NC=20, NP=10) {
    collected <- list()

    for (i in 1:2) {
        if (i==1L) {
            comp <- matrix(rnorm(NC*NP), ncol=NP)
        } else {
            comp <- Matrix::rsparsematrix(NC, NP, 0.1)
        }
        
        for (j in 1:2) {
            if (j==1L) {
                rot <- matrix(rnorm(NR*NP), ncol=NP)
            } else {
                rot <- Matrix::rsparsematrix(NR, NP, 0.1)
            }

            ref <- as.matrix(rot %*% t(comp))
            lrm <- LowRankMatrix(rot, comp)
            collected <- c(collected, list(list(ref=ref, lrm=lrm)))
        }
    }

    collected
}

##########################

expect_identical2 <- function(x, y) 
# Special check to avoid problems with tcrossprod precision
# on Windows 32-bit when one of the matrices is a dgCMatrix.
{
    if (.Platform$OS.type=="windows") {
        FUN <- expect_equal
    } else {
        FUN <- expect_identical
    }
    FUN(x, y)
}

expect_identical_unnamed <- function(x, y) {
    if (all(lengths(dimnames(x))==0L)) dimnames(x) <- NULL
    if (all(lengths(dimnames(y))==0L)) dimnames(y) <- NULL
    expect_identical2(x, y)
}

set.seed(500001)
test_that("LowRankMatrix utility functions work as expected", {
    possibles <- spawn_scenarios()
    for (test in possibles) {
        expect_s4_class(test$lrm, "LowRankMatrix")
        expect_identical2(test$lrm, LowRankMatrix(DelayedArray::seed(test$lrm)))

        expect_identical2(dim(test$lrm), dim(test$ref))
        expect_identical2(extract_array(test$lrm, list(1:10, 1:10)), test$ref[1:10, 1:10])
        expect_identical2(extract_array(test$lrm, list(1:10, NULL)), test$ref[1:10,])
        expect_identical2(extract_array(test$lrm, list(NULL, 1:10)), test$ref[,1:10])
        expect_identical_unnamed(as.matrix(test$lrm), test$ref)

        ttest <- t(test$lrm)
        expect_s4_class(ttest, "LowRankMatrix") # still a LRMat!
        expect_identical2(t(ttest), test$lrm)
        expect_identical_unnamed(as.matrix(ttest), t(test$ref))

        # Checking column names getting and setting.
        spawn_names <- sprintf("THING_%i", seq_len(ncol(test$lrm)))
        colnames(test$lrm) <- spawn_names
        expect_identical2(spawn_names, colnames(test$lrm))
        expect_s4_class(test$lrm, "LowRankMatrix") # still a LRMat!
    }
})

set.seed(500002)
test_that("LowRankMatrix subsetting works as expected", {
    expect_identical_and_lrmmat <- function(x, y) {
        expect_s4_class(x, "LowRankMatrix") # class is correctly preserved by direct seed modification.
        expect_identical_unnamed(as.matrix(x), y)
    }

    possibles <- spawn_scenarios()
    for (test in possibles) {
        i <- sample(nrow(test$lrm))
        j <- sample(ncol(test$lrm))
        expect_identical_and_lrmmat(test$lrm[i,], test$ref[i,])
        expect_identical_and_lrmmat(test$lrm[,j], test$ref[,j])
        expect_identical_and_lrmmat(test$lrm[i,j], test$ref[i,j])
        
        # Works with zero dimensions.
        expect_identical_and_lrmmat(test$lrm[0,], test$ref[0,])
        expect_identical_and_lrmmat(test$lrm[,0], test$ref[,0])
        expect_identical_and_lrmmat(test$lrm[0,0], test$ref[0,0])
        
        # Dimension dropping works as expected.
        expect_identical2(test$lrm[i[1],], test$ref[i[1],])
        expect_identical2(test$lrm[,j[1]], test$ref[,j[1]])
        expect_identical_and_lrmmat(test$lrm[i[1],drop=FALSE], test$ref[i[1],,drop=FALSE])
        expect_identical_and_lrmmat(test$lrm[,j[1],drop=FALSE], test$ref[,j[1],drop=FALSE])

        # Transposition with subsetting works as expected.
        alt <- t(test$lrm)
        expect_identical2(t(alt[,i]), test$lrm[i,])
        expect_identical2(t(alt[j,]), test$lrm[,j])

        # Subsetting behaves with column names.
        spawn_names <- sprintf("THING_%i", seq_len(ncol(test$lrm)))
        colnames(test$lrm) <- spawn_names
        colnames(test$ref) <- spawn_names
        ch <- sample(spawn_names)
        expect_identical_and_lrmmat(test$lrm[,ch], test$ref[,ch])
    }
})

set.seed(500003)
test_that("Silly inputs into LowRankMatrix work as expected", {
    # Default constructor works with different inputs.
    default <- LowRankMatrix()
    expect_identical2(dim(default), c(0L, 0L))
    val <- as.matrix(default)
    dimnames(val) <- NULL
    expect_identical2(val, matrix(0, 0, 0))

    default <- LowRankMatrix(rotation=cbind(1:5))
    expect_identical2(dim(default), c(5L, 0L))
    val <- as.matrix(default)
    dimnames(val) <- NULL
    expect_identical2(val, matrix(0, 5, 0))
    
    default <- LowRankMatrix(components=cbind(1:5))
    expect_identical2(dim(default), c(0L, 5L))
    val <- as.matrix(default)
    dimnames(val) <- NULL
    expect_identical2(val, matrix(0, 0, 5))

    # Checking erronious inputs.
    expect_error(LowRankMatrix(1, 1), "must be matrix-like")
    expect_error(LowRankMatrix(cbind(1:5), cbind(1:5, 2:6)), "must be the same")
})

##########################

library(DelayedArray)
test_that("DelayedMatrix wrapping works", {
    possibles <- spawn_scenarios(80, 50)
    for (test in possibles) {
        expect_identical_unnamed(as.matrix(test$lrm+1), test$ref+1)

        v <- rnorm(nrow(test$lrm))
        expect_identical_unnamed(as.matrix(test$lrm+v), test$ref+v)
        expect_identical_unnamed(as.matrix(test$lrm*v), test$ref*v)

        w <- rnorm(ncol(test$lrm))
        expect_identical_unnamed(as.matrix(sweep(test$lrm, 2, w, "*")), sweep(test$ref, 2, w, "*"))
    }
})

#' @export
#' @import methods
setClass("BiocSingularParam", contains="VIRTUAL", slots=c(deferred="logical", fold="numeric"))

#' @export
setClass("ExactParam", contains="BiocSingularParam")

#' @export
setClass("IrlbaParam", contains="BiocSingularParam", slots=c(extra.work="integer", args="list"))

#' @export
setClass("RandomParam", contains="BiocSingularParam", slots=c(args="list"))

#' @export
setClass("FastAutoParam", contains="BiocSingularParam")

#' @export
setClass("LowRankMatrixSeed", slots=c(rotation="ANY", components="ANY"))

#' @export
#' @importClassesFrom DelayedArray DelayedMatrix
setClass("LowRankMatrix",
    contains="DelayedMatrix",
    representation(seed="LowRankMatrixSeed")
)

#' @importFrom DelayedArray DelayedArray 
#' @importFrom ScaledMatrix ScaledMatrix
#' @importFrom BiocParallel SerialParam bpnworkers
standardize_matrix <- function(x, center=FALSE, scale=FALSE, deferred=FALSE, BPPARAM=SerialParam())
# Creates a deferred or delayed centered and scaled matrix.
# The two choices have different implications for speed and accuracy.
{
    stats <- .compute_center_and_scale(x, center, scale, bpnworkers(BPPARAM))
    center <- stats$center
    scale <- stats$scale
    if (!is.null(scale)) {
        scale[scale == 0] <- 1
    }

    if (deferred) {
        if (bpnworkers(BPPARAM)==1L) {
            original <- x # exploit original (non-DA) matrix mult functions.
        } else {
            original <- DelayedArray(x) # exploit parallelization for DAs.
        }
        X <- ScaledMatrix(original, center=center, scale=scale)

    } else {
        X <- DelayedArray(x)
        if (!is.null(center)) {
            X <- sweep(X, 2, center, "-") 
        }
        if (!is.null(scale)) {
            X <- sweep(X, 2, scale, "/")
        }
    }
    return(X)
}

#' @importFrom beachmat initializeCpp
.compute_center_and_scale <- function(x, center, scale, nthreads) {
    if (isTRUE(center) && isTRUE(scale)) {
        ptr <- initializeCpp(x)
        out <- compute_center_and_scale(ptr, nthreads)
        center <- out$center
        scale <- out$scale
    }

    if (is.logical(center)) {
        if (center) {
            ptr <- initializeCpp(x)
            center <- compute_center(ptr, nthreads)
        } else {
            center <- NULL
        }
    }

    if (is.logical(scale)) {
        if (scale) {
            ptr <- initializeCpp(x)
            tmp_center <- center
            if (is.null(tmp_center)) {
                tmp_center <- numeric(ncol(x))
            }
            scale <- compute_scale(ptr, tmp_center, nthreads)
        } else {
            scale <- NULL
        }
    }

    list(center=center, scale=scale) 
}

standardize_output_SVD <- function(res, x) 
# Provide a common standard output for all SVD functions.
{
    res$d <- as.numeric(res$d)
    res$u <- as.matrix(res$u)
    rownames(res$u) <- rownames(x)
    res$v <- as.matrix(res$v)
    rownames(res$v) <- colnames(x)
    res[c("d", "u", "v")]
}

# This explicitly unit tests utilities that are indirectly covered elsewhere.
# library(BiocSingular); library(testthat); source("setup.R"); source("test-utils.R")

test_that("use_crossprod works correctly", {
    expect_true(BiocSingular:::use_crossprod(matrix(0, nrow=10, ncol=100), 1))    
    expect_true(BiocSingular:::use_crossprod(matrix(0, nrow=10, ncol=100), 5))
    expect_true(BiocSingular:::use_crossprod(matrix(0, nrow=10, ncol=100), 10))
    expect_false(BiocSingular:::use_crossprod(matrix(0, nrow=10, ncol=100), 11))
    expect_false(BiocSingular:::use_crossprod(matrix(0, nrow=10, ncol=100), Inf))

    expect_true(BiocSingular:::use_crossprod(matrix(0, nrow=100, ncol=10), 1))
    expect_true(BiocSingular:::use_crossprod(matrix(0, nrow=100, ncol=10), 5))
    expect_true(BiocSingular:::use_crossprod(matrix(0, nrow=100, ncol=10), 10))
    expect_false(BiocSingular:::use_crossprod(matrix(0, nrow=100, ncol=10), 11))
    expect_false(BiocSingular:::use_crossprod(matrix(0, nrow=100, ncol=10), Inf))
})

test_that("center and scale calculations work correctly", {
    for (n in 1:2) {
        for (it in 1:4) {
            if (it==1L) {
                A <- matrix(runif(2000), 50, 40)
            } else if (it==2L) {
                A <- t(DelayedArray(matrix(rpois(2000, lambda=5), 50, 40))) # dense, prefers rows
            } else if (it==3L) {
                A <- Matrix::rsparsematrix(50, 40, density=0.1)
            } else {
                A <- t(DelayedArray(Matrix::rsparsematrix(50, 40, density=0.1))) # sparse, prefers rows
            }

            A0 <- as.matrix(A)
            out <- BiocSingular:::.compute_center_and_scale(A, center=TRUE, scale=FALSE, nthreads=n)
            expect_equal(out$center, colMeans(A0))
            expect_null(out$scale)
            expect_equal(out$center, BiocSingular:::compute_center(beachmat::initializeCpp(A), n))

            out <- BiocSingular:::.compute_center_and_scale(A, center=TRUE, scale=TRUE, nthreads=n)
            expect_equal(out$center, colMeans(A0))
            B <- sweep(A0, 2, out$center, "-")
            ref <- sqrt(Matrix::colSums(B^2)/(nrow(B)-1))
            expect_equal(out$scale, ref)

            out <- BiocSingular:::.compute_center_and_scale(A, center=FALSE, scale=TRUE, nthreads=n)
            ref <- sqrt(Matrix::colSums(A0^2)/(nrow(A0)-1))
            expect_equal(out$scale, ref)
            expect_null(out$center)

            center <- rnorm(ncol(A0))
            out <- BiocSingular:::.compute_center_and_scale(A, center=center, scale=TRUE, nthreads=n)
            B <- sweep(A0, 2, center, "-")
            ref <- sqrt(Matrix::colSums(B^2)/(nrow(B)-1))
            expect_equal(out$center, center)
            expect_equal(out$scale, ref)

            expect_error(BiocSingular:::.compute_center_and_scale(A, center=1, scale=TRUE, nthreads=n), "should be equal")
        }
    }
})

test_that("center and scale calculations work for edge cases", {
    for (it in 1:4) {
        if (it==1L) {
            A <- matrix(runif(10), 1, 10)
        } else if (it==2L) {
            A <- t(DelayedArray(matrix(rnorm(10), 10, 1))) # dense, prefers rows
        }

        out <- BiocSingular:::.compute_center_and_scale(A, center=TRUE, scale=TRUE, nthreads=1)
        expect_identical(out$center, A[1,])
        expect_identical(out$scale, rep(NA_real_, 10))

        out <- BiocSingular:::.compute_center_and_scale(A, center=TRUE, scale=FALSE, nthreads=1)
        expect_identical(out$center, A[1,])

        out <- BiocSingular:::.compute_center_and_scale(A, center=FALSE, scale=TRUE, nthreads=1)
        expect_identical(out$scale, rep(NA_real_, 10))
    }

    for (it in 1:4) {
        if (it==1L) {
            A <- matrix(runif(0), 0, 10)
        } else if (it==2L) {
            A <- t(DelayedArray(matrix(rnorm(0), 10, 0))) # dense, prefers rows
        }

        out <- BiocSingular:::.compute_center_and_scale(A, center=TRUE, scale=TRUE, nthreads=1)
        expect_identical(out$center, rep(NA_real_, 10))
        expect_identical(out$scale, rep(NA_real_, 10))

        out <- BiocSingular:::.compute_center_and_scale(A, center=TRUE, scale=FALSE, nthreads=1)
        expect_identical(out$center, rep(NA_real_, 10))

        out <- BiocSingular:::.compute_center_and_scale(A, center=FALSE, scale=TRUE, nthreads=1)
        expect_identical(out$scale, rep(NA_real_, 10))
    }

    empty <- matrix(0, 10, 0)
    out <- BiocSingular:::.compute_center_and_scale(empty, center=TRUE, scale=TRUE, nthreads=1)
    expect_identical(out$center, numeric(0))
    expect_identical(out$scale, numeric(0))

    out <- BiocSingular:::.compute_center_and_scale(empty, center=TRUE, scale=FALSE, nthreads=1)
    expect_identical(out$center, numeric(0))

    out <- BiocSingular:::.compute_center_and_scale(empty, center=FALSE, scale=TRUE, nthreads=1)
    expect_identical(out$scale, numeric(0))
})

test_that("standardize_matrix works correctly", {
    A <- matrix(runif(2000), 50, 40)

    # Cycling through all possible centering and scaling options.
    for (center in list(TRUE, FALSE, NULL, rnorm(ncol(A)))) {
        for (scale in list(TRUE, FALSE, NULL, 1+runif(ncol(A)))) {
            ref <- scale(A, 
                center=if (is.null(center)) FALSE else center, 
                scale=if (is.null(scale)) FALSE else scale)
            ref <- ref[,] # remove attributes

            out <- BiocSingular:::standardize_matrix(A, center=center, scale=scale)
            expect_s4_class(out, "DelayedArray")
            expect_equivalent(as.matrix(out), ref)
            
            out <- BiocSingular:::standardize_matrix(A, center=center, scale=scale, deferred=TRUE)
            expect_s4_class(out, "ScaledMatrix")
            expect_equivalent(as.matrix(out), ref)

            if (.Platform$OS.type!="windows") { # as safeBPParam uses SerialParam, which doesn't wrap the matrix in a DA.
                out <- BiocSingular:::standardize_matrix(A, center=center, scale=scale, deferred=TRUE, BPPARAM=safeBPParam(2))
                expect_s4_class(out, "ScaledMatrix")
                expect_s4_class(DelayedArray::seed(out)@.matrix, "DelayedArray")
                expect_equivalent(as.matrix(out), ref)
            }
        }
    }
})

test_that("standardize_matrix behaves with no-variance rows", {
    A <- matrix(10, 50, 40)
    out <- BiocSingular:::standardize_matrix(A, center=TRUE, scale=TRUE)
    expect_equal(as.matrix(out), matrix(0, 50, 40))

    out <- BiocSingular:::standardize_matrix(A, center=TRUE, scale=TRUE, deferred=TRUE)
    expect_equal(as.matrix(out), matrix(0, 50, 40))
})

test_that("standardize_output_SVD works correctly", {
    out <- BiocSingular:::standardize_output_SVD(list(u=1:5, d=TRUE, v=1:10), NULL)
    expect_identical(names(out), c("d", "u", "v"))
    expect_identical(out$u, cbind(1:5))
    expect_identical(out$v, cbind(1:10))
    expect_identical(out$d, 1)

    # Handles alternative matrix types in 'u' and 'v'.
    U <- Matrix::rsparsematrix(10, 20, 0.12)
    V <- DelayedArray::DelayedArray(matrix(runif(200), 10, 20))
    out <- BiocSingular:::standardize_output_SVD(list(u=U, d=1:5, v=V), NULL)
    expect_identical(names(out), c("d", "u", "v"))
    expect_identical(out$u, as.matrix(U)) 
    expect_identical(out$v, as.matrix(V))
    expect_identical(out$d, as.numeric(1:5))

    # Sets names, if the matrix was named.
    mat <- matrix(0, 5, 10, dimnames=list(letters[1:5], LETTERS[1:10]))
    out <- BiocSingular:::standardize_output_SVD(list(u=1:5, d=TRUE, v=1:10), mat)
    expect_identical(rownames(out$u), rownames(mat))
    expect_identical(rownames(out$v), colnames(mat))
})

#' @export
#' @importFrom BiocParallel bpstart bpstop SerialParam
#' @importFrom utils head
#' @importFrom DelayedArray getAutoBPPARAM setAutoBPPARAM
runExactSVD <- function(x, k=min(dim(x)), nu=k, nv=k, center=FALSE, scale=FALSE, deferred=FALSE, fold=Inf, BPPARAM=SerialParam())
{
    checked <- check_numbers(x, k=k, nu=nu, nv=nv)
    k <- checked$k
    nv <- checked$nv
    nu <- checked$nu

    # Setting up the parallelization environment.
    old <- getAutoBPPARAM()
    setAutoBPPARAM(BPPARAM)
    on.exit(setAutoBPPARAM(old))

    if (!.bpisup2(BPPARAM)) {
        bpstart(BPPARAM)
        on.exit(bpstop(BPPARAM), add=TRUE)
    }

    x <- standardize_matrix(x, center=center, scale=scale, deferred=deferred, BPPARAM=BPPARAM)
    if (use_crossprod(x, fold)) {
        res <- svd_via_crossprod(x, k=k, nu=nu, nv=nv, FUN=safe_svd)
    } else {
        res <- safe_svd(as.matrix(x), nu=nu, nv=nv)
        res$d <- head(res$d, k)
        res <- standardize_output_SVD(res, x)
    }

    res
}

safe_svd <- function(x, nu, nv) 
# Wrapper that guarantees return of U, D and V, even if nu or nv are zero. 
{
    out <- svd(x, nu=nu, nv=nv)
    if (!nu) {
        out$u <- matrix(0, nrow(x), 0)
    }
    if (!nv) {
        out$v <- matrix(0, ncol(x), 0)
    }
    out
}

# Tests runExactSVD().
# library(testthat); library(BiocSingular); source("setup.R"); source("test-exact-svd.R")

set.seed(50000)
test_that("exact SVD works on square matrices", {
    y <- matrix(rnorm(10000), ncol=100, nrow=100)
    out <- runExactSVD(y, fold=Inf)
    ref <- svd(y)
    expect_equal(out, ref)

    # Handles truncation.
    out <- runExactSVD(y, k=10, nv=5, nu=3, fold=Inf)
    ref <- svd(y, nv=5, nu=3)
    ref$d <- ref$d[1:10]
    expect_equal(out, ref)

    out <- runExactSVD(y, k=1, nv=5, nu=3, fold=Inf)
    ref <- svd(y, nv=5, nu=3)
    ref$d <- ref$d[1]
    expect_equal(out, ref)

    # Handles zeroes.
    out0 <- runExactSVD(y, k=0, nv=0, nu=0)
    expect_equal(out0$d, numeric(0))
    expect_equal(out0$u, ref$u[,0])
    expect_equal(out0$v, ref$v[,0])
})

set.seed(50001)
test_that("exact SVD works on thin matrices", {
    y <- matrix(rnorm(10000), ncol=10)
    out <- runExactSVD(y, fold=1)
    ref <- svd(y)
    expect_equal_svd(out, ref)

    # Handles truncation.
    out <- runExactSVD(y, k=5, nv=4, nu=2, fold=1)
    ref <- svd(y, nu=2, nv=4)
    ref$d <- ref$d[1:5]
    expect_equal_svd(out, ref)

    out <- runExactSVD(y, k=1, nv=6, nu=2, fold=1)
    ref <- svd(y, nu=2, nv=6)
    ref$d <- ref$d[1]
    expect_equal_svd(out, ref)

    # Handles zeroes.
    out0 <- runExactSVD(y, k=0, nv=0, nu=0, fold=1)
    expect_equal(out0$d, numeric(0))
    expect_equal(out0$u, ref$u[,0])
    expect_equal(out0$v, ref$v[,0])
})

set.seed(50002)
test_that("exact SVD works on fat matrices", {
    y <- matrix(rnorm(10000), nrow=10)
    out <- runExactSVD(y, fold=1)
    ref <- svd(y)
    expect_equal_svd(out, ref)

    # Handles truncation.
    out <- runExactSVD(y, k=7, nv=6, nu=2, fold=1)
    ref <- svd(y, nu=2, nv=6)
    ref$d <- ref$d[1:7]
    expect_equal_svd(out, ref)

    out <- runExactSVD(y, k=1, nv=6, nu=2, fold=1)
    ref <- svd(y, nu=2, nv=6)
    ref$d <- ref$d[1]
    expect_equal_svd(out, ref)

    # Handles zeroes.
    out0 <- runExactSVD(y, k=0, nv=0, nu=0, fold=1)
    expect_equal(out0$d, numeric(0))
    expect_equivalent(out0$u, ref$u[,0])
    expect_equivalent(out0$v, ref$v[,0])
})

set.seed(50003)
test_that("exact SVD works with centering and scaling", {
    y <- matrix(rnorm(10000), ncol=50)
    center <- runif(ncol(y))
    scale <- runif(ncol(y))

    ry <- scale(y, center=center, scale=scale)
    ref <- svd(ry)
    out <- runExactSVD(y, center=center, scale=scale, fold=Inf)
    expect_equal_svd(out, ref)

    # Works with the crossproduct.
    y <- matrix(rnorm(10000), ncol=10)
    center <- runif(ncol(y))
    scale <- runif(ncol(y))

    ry <- scale(y, center=center, scale=scale)
    ref <- svd(ry)
    out <- runExactSVD(y, center=center, scale=scale, fold=1)
    expect_equal_svd(out, ref)

    # Works with deferred operations.
    y <- matrix(rnorm(10000), ncol=10)
    center <- runif(ncol(y))
    scale <- runif(ncol(y))

    ry <- scale(y, center=center, scale=scale)
    ref <- svd(ry)
    out <- runExactSVD(y, center=center, scale=scale, deferred=TRUE)
    expect_equal_svd(out, ref)
})

set.seed(500041)
test_that("exact SVD handles named inputs", {
    y <- matrix(rnorm(10000), ncol=50)
    rownames(y) <- sprintf("THING_%i", seq_len(nrow(y)))
    colnames(y) <- sprintf("STUFF_%i", seq_len(ncol(y)))

    out <- runExactSVD(y, fold=Inf)
    expect_identical(rownames(out$u), rownames(y))
    expect_identical(rownames(out$v), colnames(y))

    out <- runExactSVD(y, fold=1)
    expect_identical(rownames(out$u), rownames(y))
    expect_identical(rownames(out$v), colnames(y))
})

set.seed(50004)
test_that("exact SVD fails gracefully with silly inputs", {
    y <- matrix(rnorm(10000), ncol=50)
    expect_error(runExactSVD(y, k=-1), "non-negative")
    expect_error(runExactSVD(y, nu=-1), "non-negative")
    expect_error(runExactSVD(y, nv=-1), "non-negative")

    expect_warning(runExactSVD(y, k=1e6), "requested than available")
    expect_warning(runExactSVD(y, nu=1e6), "requested than available")
    expect_warning(runExactSVD(y, nv=1e6), "requested than available")

    expect_warning(out <- runExactSVD(y, k=Inf), NA)
    expect_identical(length(out$d), min(dim(y)))
    expect_warning(runExactSVD(y, nu=Inf), NA)
    expect_identical(ncol(out$u), min(dim(y)))
    expect_warning(runExactSVD(y, nv=Inf), NA)
    expect_identical(ncol(out$v), min(dim(y)))
})

#' @export
#' @importFrom BiocParallel bpstart bpstop bpnworkers SerialParam
#' @importFrom irlba irlba
#' @importFrom utils head
#' @importClassesFrom Matrix dgCMatrix
#' @importFrom DelayedArray getAutoBPPARAM setAutoBPPARAM
runIrlbaSVD <- function(x, k=5, nu=k, nv=k, center=FALSE, scale=FALSE, deferred=FALSE, extra.work=7, ..., 
    fold=Inf, BPPARAM=SerialParam())
{
    if (nu==0 && nv==0 && k==0) {
        return(list(d=numeric(0),
                    u=matrix(0, nrow(x), 0),
                    v=matrix(0, ncol(x), 0)))
    }

    # irlba() errors when asking for exactly the maximum number of SVs,
    # hence the lowered 'limit'.
    checked <- check_numbers(k=k, nu=nu, nv=nv, limit=min(dim(x))-1L)
    k <- checked$k
    nv <- checked$nv
    nu <- checked$nu

    # Setting up the parallelization environment.
    old <- getAutoBPPARAM()
    setAutoBPPARAM(BPPARAM)
    on.exit(setAutoBPPARAM(old))

    if (!.bpisup2(BPPARAM)) {
        bpstart(BPPARAM)
        on.exit(bpstop(BPPARAM), add=TRUE)
    }

    args <- list(work=max(k, nu, nv) + extra.work, ...)

    if (use_crossprod(x, fold)) {
        x <- standardize_matrix(x, center=center, scale=scale, deferred=deferred, BPPARAM=BPPARAM)
        res <- do.call(svd_via_crossprod, c(list(x, k=k, nu=nu, nv=nv, FUN=irlba, BPPARAM=BPPARAM), args))

    } else {
        args$nu <- nu
        args$nv <- max(k, nv)

        if (bpnworkers(BPPARAM)==1L) {
            stats <- .compute_center_and_scale(x, center, scale, nthreads = bpnworkers(BPPARAM))

            # Use irlba's native 'center' and 'scale', avoid overhead of Delayed/DeferredMatrix wrapper in 'standardize_matrix'.
            # Also try to use 'fastpath=TRUE' if possible, depending on the class of 'x'.
            res <- do.call(irlba, c(args, list(A=x, center=stats$center, scale=stats$scale)))

        } else {
            x <- standardize_matrix(x, center=center, scale=scale, deferred=deferred, BPPARAM=BPPARAM)
            res <- do.call(irlba, c(list(A=x, fastpath=FALSE), args))
        }

        res$v <- res$v[,seq_len(nv),drop=FALSE]
        res$d <- head(res$d, k)
        res <- standardize_output_SVD(res, x)
    }

    res
}

# Tests runIrlbaSVD().
# library(testthat); library(BiocSingular); source("setup.R"); source("test-irlba-svd.R")

library(irlba)

set.seed(9000)
test_that("IRLBA works on input matrices", {

    y <- matrix(rnorm(50000), ncol=200)
    set.seed(100)
    out <- runIrlbaSVD(y, k=5, fold=Inf)
    set.seed(100)
    ref <- irlba(y, nv=5)
    expect_equal_svd(out, ref[c("d", "u", "v")])

    # Handles truncation.
    set.seed(100)
    out <- runIrlbaSVD(y, k=10, nv=5, nu=3, fold=Inf)
    set.seed(100)
    ref <- irlba(y, nv=10, nu=3)
    ref$v <- ref$v[,1:5]
    expect_equal_svd(out, ref[c("d", "u", "v")])

    set.seed(100)
    out <- runIrlbaSVD(y, k=1, nv=5, nu=3, fold=Inf)
    set.seed(100)
    ref <- irlba(y, nv=5, nu=3)
    ref$d <- ref$d[1]
    expect_equal_svd(out, ref[c("d", "u", "v")])

    # Handles zeroes.
    out0 <- runIrlbaSVD(y, k=0, nv=0, nu=0)
    expect_equal(out0$d, numeric(0))
    expect_equal(out0$u, ref$u[,0])
    expect_equal(out0$v, ref$v[,0])
})

set.seed(9001)
test_that("IRLBA works on thin matrices", {
    y <- matrix(rnorm(10000), ncol=10)
    set.seed(200)
    out <- runIrlbaSVD(y, k=3, fold=1)
    set.seed(200)
    ref <- irlba(y, nv=3, nu=3)
    expect_equal_svd(out, ref)

    # Handles truncation.
    set.seed(200)
    out <- runIrlbaSVD(y, k=5, nv=3, nu=2, fold=1)
    set.seed(200)
    ref <- irlba(y, nu=2, nv=5)
    ref$v <- ref$v[,1:3]
    expect_equal_svd(out, ref)

    set.seed(200)
    out <- runIrlbaSVD(y, k=1, nv=3, nu=2, fold=1)
    set.seed(200)
    ref <- irlba(y, nu=2, nv=3)
    ref$d <- ref$d[1]
    expect_equal_svd(out, ref)
})

set.seed(9002)
test_that("IRLBA works on fat matrices", {
    y <- matrix(rnorm(10000), nrow=10)
    set.seed(300)
    out <- runIrlbaSVD(y, k=4, fold=1)
    set.seed(300)
    ref <- irlba(y, nu=4, nv=4)
    expect_equal_svd(out, ref)

    # Handles truncation.
    set.seed(300)
    out <- runIrlbaSVD(y, k=5, nv=4, nu=2, fold=1)
    set.seed(300)
    ref <- irlba(y, nu=2, nv=5)
    ref$v <- ref$v[,1:4]
    expect_equal_svd(out, ref)

    set.seed(300)
    out <- runIrlbaSVD(y, k=1, nv=6, nu=2, fold=1)
    set.seed(300)
    ref <- irlba(y, nu=2, nv=6)
    ref$d <- ref$d[1]
    expect_equal_svd(out, ref)
})

set.seed(9003)
test_that("IRLBA works with alternative multiplication", {
    # Lower tol to avoid numeric precision issues.
    y <- matrix(rnorm(50000), ncol=100)
    set.seed(100)
    out <- runIrlbaSVD(y, k=5, BPPARAM=safeBPParam(2), tol=1e-8, fold=Inf)
    set.seed(100)
    ref <- irlba(y, nv=5, tol=1e-8)
    expect_equal_svd(out, ref[c("d", "u", "v")], tol=1e-6)

    # Handles truncation.
    set.seed(100)
    out <- runIrlbaSVD(y, k=5, nv=2, nu=3, BPPARAM=safeBPParam(2), tol=1e-8, fold=Inf)
    set.seed(100)
    ref <- irlba(y, nv=5, nu=3, tol=1e-8)
    ref$v <- ref$v[,1:2]
    expect_equal_svd(out, ref[c("d", "u", "v")], tol=1e-6)
})

set.seed(9004)
test_that("IRLBA works with centering and scaling", {
    y <- matrix(rnorm(10000), ncol=50)
    center <- runif(ncol(y))
    scale <- runif(ncol(y))

    set.seed(100)
    ref <- irlba(y, k=5, center=center, scale=scale, tol=1e-8)
    set.seed(100)
    out <- runIrlbaSVD(y, k=5, center=center, scale=scale, fold=Inf, tol=1e-8) 
    expect_equal_svd(out, ref)

    ry <- scale(y, center=center, scale=scale)
    set.seed(100)
    ref2 <- irlba(ry, nv=5, nu=5, tol=1e-8)
    expect_equal_svd(out, ref2)

    # Works with logical values.
    ry <- scale(y, center=TRUE, scale=TRUE)
    set.seed(300)
    ref <- irlba(ry, nu=5, nv=5, tol=1e-8)
    set.seed(300)
    out <- runIrlbaSVD(y, k=5, center=TRUE, scale=TRUE, fold=1, tol=1e-8)
    expect_equal_svd(out, ref, tol=1e-6)
})

set.seed(9004)
test_that("IRLBA centering and scaling interact happily with other modes", {
    # Works with the cross-product.
    y <- matrix(rnorm(10000), ncol=20)
    center <- runif(ncol(y))
    scale <- runif(ncol(y))
    
    ry <- scale(y, center=center, scale=scale)
    set.seed(200)
    ref <- irlba(ry, nu=5, nv=5, tol=1e-8)
    set.seed(200)
    out <- runIrlbaSVD(y, k=5, center=center, scale=scale, fold=1, tol=1e-8)
    expect_equal_svd(out, ref, tol=1e-6)

    # Works with the alternative multiplication.
    set.seed(100)
    out <- runIrlbaSVD(y, k=6, center=center, scale=scale, BPPARAM=safeBPParam(2), tol=1e-8, fold=Inf)
    set.seed(100)
    ref <- irlba(ry, nu=6, nv=6, tol=1e-8)
    expect_equal_svd(out, ref, tol=1e-6)

    # Works with our deferred multiplication (which also requires parallelization,
    # in order to not just use irlba's deferred methods directly).
    set.seed(100)
    ref <- irlba(ry, nu=7, nv=7, tol=1e-8)
    set.seed(100)
    out <- runIrlbaSVD(y, k=7, center=center, scale=scale, deferred=TRUE, BPPARAM=safeBPParam(2), tol=1e-8, fold=Inf)
    expect_equal_svd(out, ref, tol=1e-6)
})

set.seed(90041)
test_that("irlba SVD handles named inputs", {
    y <- matrix(rnorm(10000), ncol=50)
    rownames(y) <- sprintf("THING_%i", seq_len(nrow(y)))
    colnames(y) <- sprintf("STUFF_%i", seq_len(ncol(y)))

    out <- runIrlbaSVD(y, k=3, fold=Inf)
    expect_identical(rownames(out$u), rownames(y))
    expect_identical(rownames(out$v), colnames(y))

    out <- runIrlbaSVD(y, k=3, fold=1)
    expect_identical(rownames(out$u), rownames(y))
    expect_identical(rownames(out$v), colnames(y))
})

set.seed(9005)
test_that("IRLBA fails gracefully with silly inputs", {
    y <- matrix(rnorm(10000), ncol=50)
    expect_error(runIrlbaSVD(y, k=-1), "non-negative")
    expect_error(runIrlbaSVD(y, nu=-1), "non-negative")
    expect_error(runIrlbaSVD(y, nv=-1), "non-negative")

    expect_warning(runIrlbaSVD(y, k=1e6), "requested than available")
    expect_warning(runIrlbaSVD(y, nu=1e6), "requested than available")
    expect_warning(runIrlbaSVD(y, nv=1e6), "requested than available")
})

#' @title The DeferredMatrix class
#'
#' @description 
#' This has been deprecated in favor of the \linkS4class{ScaledMatrix} class 
#' from the \pkg{ScaledMatrix} package - use those constructors instead.
#'
#' @docType class
#' @name DeferredMatrix
#' @aliases
#' DeferredMatrixSeed
NULL

#' @export
#' @importFrom ScaledMatrix ScaledMatrixSeed
DeferredMatrixSeed <- function(x, center=NULL, scale=NULL) {
    .Deprecated("ScaledMatrixSeed")
    ScaledMatrixSeed(x, center=center, scale=scale)
}

#' @export
#' @importFrom ScaledMatrix ScaledMatrix
DeferredMatrix <- function(x, center=NULL, scale=NULL) {
    .Deprecated("ScaledMatrix")
    ScaledMatrix(x, center=center, scale=scale)
}

# Generated by using Rcpp::compileAttributes() -> do not edit by hand
# Generator token: 10BE3573-1514-4C36-9D1C-5A225CD40393

set_executor <- function(ptr) {
    .Call('_BiocSingular_set_executor', PACKAGE = 'BiocSingular', ptr)
}

#' @useDynLib BiocSingular
#' @importFrom Rcpp sourceCpp
compute_center <- function(mat, nthreads) {
    .Call('_BiocSingular_compute_center', PACKAGE = 'BiocSingular', mat, nthreads)
}

compute_center_and_scale <- function(mat, nthreads) {
    .Call('_BiocSingular_compute_center_and_scale', PACKAGE = 'BiocSingular', mat, nthreads)
}

compute_scale <- function(mat, centers, nthreads) {
    .Call('_BiocSingular_compute_scale', PACKAGE = 'BiocSingular', mat, centers, nthreads)
}

#' @export
#' @importFrom BiocParallel SerialParam bpstart bpstop 
#' @importFrom utils head
#' @importClassesFrom DelayedArray DelayedMatrix
#' @importFrom methods is
#' @importFrom DelayedArray getAutoBPPARAM setAutoBPPARAM
runRandomSVD <- function(x, k=5, nu=k, nv=k, center=FALSE, scale=FALSE, deferred=FALSE, ..., fold=Inf, BPPARAM=SerialParam())
# Wrapper for irlba(), switching to the appropriate multiplication algorithm for  
{
    if (nu==0 && nv==0 && k==0) {
        return(list(d=numeric(0),
                    u=matrix(0, nrow(x), 0),
                    v=matrix(0, ncol(x), 0)))
    }

    checked <- check_numbers(x, k=k, nu=nu, nv=nv)
    k <- checked$k
    nv <- checked$nv
    nu <- checked$nu

    # Setting up the parallelization environment.
    old <- getAutoBPPARAM()
    setAutoBPPARAM(BPPARAM)
    on.exit(setAutoBPPARAM(old))

    if (!.bpisup2(BPPARAM)) {
        bpstart(BPPARAM)
        on.exit(bpstop(BPPARAM), add=TRUE)
    }

    x <- standardize_matrix(x, center=center, scale=scale, deferred=deferred, BPPARAM=BPPARAM)

    if (use_crossprod(x, fold)) {
        FUN <- function(x, nu, nv, ...) { 
            # FUN is assumed to only take 'nu' and 'nv',
            # so we need to fill-in rsvd()'s version of 'k'.
            safe_rsvd(x, k=max(nu, nv), nu=nu, nv=nv, ...)
        }
        res <- svd_via_crossprod(x, k=k, nu=nu, nv=nv, FUN=FUN, ...) 

    } else {
        res <- safe_rsvd(x, k=max(nu, nv, k), nu=nu, nv=nv, ...) 
        res$d <- head(res$d, k)
        res <- standardize_output_SVD(res, x)
    }

    res
}

#' @importFrom rsvd rsvd 
safe_rsvd <- function(x, k, nu, nv, ...)
# Wrapper that guarantees return of U, D and V, even if nu or nv are zero.
{
    out <- rsvd(x, k=k, nu=nu, nv=nv, ...)
    if (!nu) {
        out$u <- matrix(0, nrow(x), 0)
    }
    if (!nv) {
        out$v <- matrix(0, ncol(x), 0)
    }
    out
}

#' @export
bsfold <- function(object) object@fold

#' @export
bsdeferred <- function(object) object@deferred

bsargs <- function(object) object@args

#' @importFrom S4Vectors setValidity2
setValidity2("BiocSingularParam", function(object) {
    msg <- character(0)

    if (length(bsfold(object))!=1L) {
        msg <- c(msg, "'fold' should be a numeric scalar")
    }
    if (bsfold(object) < 1) {
        msg <- c(msg, "'fold' should be no less than 1")
    }

    if (length(bsdeferred(object))!=1L) {
        msg <- c(msg, "'deferred' should be a numeric scalar")
    }

    if (length(msg)) {
        return(msg)
    }
    return(TRUE)
})

#' @export
#' @importFrom methods show 
setMethod("show", "BiocSingularParam", function(object) {
    cat(sprintf("class: %s\n", class(object)))
    cat(sprintf("cross-product fold-threshold: %.2f\n", bsfold(object)))
    cat(sprintf("deferred centering/scaling: %s\n", ifelse(bsdeferred(object), "on", "off")))
})

#' @export
#' @importFrom methods new
ExactParam <- function(deferred=FALSE, fold=Inf) {
    new("ExactParam", deferred=as.logical(deferred), fold=as.numeric(fold))
}

#' @export
#' @importFrom methods new
IrlbaParam <- function(deferred=FALSE, fold=Inf, extra.work=7, ...) {
    new("IrlbaParam", deferred=as.logical(deferred), fold=as.numeric(fold), extra.work=as.integer(extra.work), args=list(...))
}

ip_extra <- function(object) object@extra.work

setValidity("IrlbaParam", function(object) {
    msg <- character(0)
    if (ip_extra(object) < 0L) {
        msg <- c(msg, "'extra.work' should be non-negative")
    }
    if (length(msg)) {
        return(msg)
    }
    return(TRUE)
})

#' @export
#' @importFrom methods show 
setMethod("show", "IrlbaParam", function(object) {
    callNextMethod()
    cat(sprintf("extra workspace: %i\n", ip_extra(object)))
    extra.names <- names(bsargs(object))
    if (length(extra.names) > 3) extra.names <- c(extra.names[seq_len(3)], "...")
    cat(sprintf("additional arguments(%i): %s\n", length(bsargs(object)), paste(extra.names, collapse=", ")))
})

#' @export
#' @importFrom methods new
RandomParam <- function(deferred=FALSE, fold=Inf, ...) {
    new("RandomParam", deferred=as.logical(deferred), fold=as.numeric(fold), args=list(...))
}

#' @export
#' @importFrom methods show 
setMethod("show", "RandomParam", function(object) {
    callNextMethod()
    extra.names <- names(bsargs(object))
    if (length(extra.names) > 3) extra.names <- c(extra.names[seq_len(3)], "...")
    cat(sprintf("additional arguments(%i): %s\n", length(bsargs(object)), paste(extra.names, collapse=", ")))
})

#' @export
#' @importFrom methods new
FastAutoParam <- function(deferred=FALSE, fold=Inf) {
    new("FastAutoParam", deferred=as.logical(deferred), fold=as.numeric(fold))
}

# Tests dispatch in the runSVD() function.
# library(BiocSingular); library(testthat); source("test-svd.R")

set.seed(99001)
test_that("exact method dispatches correctly", {
    y <- matrix(rnorm(10000), ncol=100, nrow=100)
    expect_identical(runExactSVD(y, k=3, fold=Inf), runSVD(y, k=3, BSPARAM=ExactParam(fold=Inf)))
    expect_identical(runExactSVD(y, k=4, fold=1), runSVD(y, k=4, BSPARAM=ExactParam(fold=1)))
    expect_identical(runExactSVD(y, k=5, deferred=TRUE), runSVD(y, k=5, BSPARAM=ExactParam(deferred=TRUE)))
    
    # Other arguments are passed along.    
    expect_identical(runExactSVD(y, k=5, center=TRUE), runSVD(y, k=5, center=TRUE, BSPARAM=ExactParam()))
    expect_identical(runExactSVD(y, k=5, scale=TRUE), runSVD(y, k=5, scale=TRUE, BSPARAM=ExactParam()))

    # Missing method dispatches to exact.
    expect_identical(runExactSVD(y, k=6), runSVD(y, k=6))
})

set.seed(99002)
test_that("irlba method dispatches correctly", {
    y <- matrix(rnorm(10000), ncol=100, nrow=100)
    
    set.seed(100); left <- runIrlbaSVD(y, k=3, fold=Inf)
    set.seed(100); right<- runSVD(y, k=3, BSPARAM=IrlbaParam(fold=Inf))
    expect_identical(left, right)

    set.seed(200); left <- runIrlbaSVD(y, k=4, fold=1)
    set.seed(200); right <- runSVD(y, k=4, BSPARAM=IrlbaParam(fold=1))
    expect_identical(left, right)

    set.seed(300); left <- runIrlbaSVD(y, k=5, deferred=TRUE)
    set.seed(300); right <- runSVD(y, k=5, BSPARAM=IrlbaParam(deferred=TRUE))
    expect_identical(left, right)
    
    # Other arguments are passed along.    
    set.seed(400); left <- runIrlbaSVD(y, k=5, center=TRUE)
    set.seed(400); right <- runSVD(y, k=5, center=TRUE, BSPARAM=IrlbaParam())
    expect_identical(left, right)

# irlba doesn't handle scale=TRUE, for reasons unknown to me.
#    set.seed(500); left <- runIrlbaSVD(y, k=5, scale=TRUE)
#    set.seed(500); right <- runSVD(y, k=5, scale=TRUE, BSPARAM=IrlbaParam())
#    expect_identical(left, right)
})

set.seed(99003)
test_that("random method dispatches correctly", {
    y <- matrix(rnorm(10000), ncol=100, nrow=100)
    
    set.seed(100); left <- runRandomSVD(y, k=3, fold=Inf)
    set.seed(100); right<- runSVD(y, k=3, BSPARAM=RandomParam(fold=Inf))
    expect_identical(left, right)

    set.seed(200); left <- runRandomSVD(y, k=4, fold=1)
    set.seed(200); right <- runSVD(y, k=4, BSPARAM=RandomParam(fold=1))
    expect_identical(left, right)

    set.seed(300); left <- runRandomSVD(y, k=5, deferred=TRUE)
    set.seed(300); right <- runSVD(y, k=5, BSPARAM=RandomParam(deferred=TRUE))
    expect_identical(left, right)
    
    # Other arguments are passed along.    
    set.seed(400); left <- runRandomSVD(y, k=5, center=TRUE)
    set.seed(400); right <- runSVD(y, k=5, center=TRUE, BSPARAM=RandomParam())
    expect_identical(left, right)

    set.seed(500); left <- runRandomSVD(y, k=5, scale=TRUE)
    set.seed(500); right <- runSVD(y, k=5, scale=TRUE, BSPARAM=RandomParam())
    expect_identical(left, right)
})

set.seed(99003)
test_that("fast automatic method dispatches correctly", {
    y <- matrix(rnorm(10000), ncol=100, nrow=100)

    set.seed(100); left <- runSVD(y, k=3, BSPARAM=FastAutoParam())
    set.seed(100); right<- runSVD(y, k=3, BSPARAM=IrlbaParam())
    expect_identical(left, right)
    
    set.seed(200); left <- runSVD(y, k=3, BSPARAM=FastAutoParam(fold=1))
    set.seed(200); right<- runSVD(y, k=3, BSPARAM=IrlbaParam(fold=1))
    expect_identical(left, right)

    dy <- DelayedArray(y)
    set.seed(300); left <- runSVD(dy, k=3, BSPARAM=FastAutoParam())
    set.seed(300); right<- runSVD(dy, k=3, BSPARAM=RandomParam())
    expect_identical(left, right)

    dfm <- ScaledMatrix(y)
    set.seed(400); left <- runSVD(dfm, k=3, BSPARAM=FastAutoParam())
    set.seed(400); right<- runSVD(dfm, k=3, BSPARAM=IrlbaParam())
    expect_identical(left, right)
})

# Tests the runPCA() function.
# library(testthat); library(BiocSingular); source("setup.R"); source("test-pca.R")

set.seed(10000)
test_that("runPCA with exact SVD matches up to the reference implementation", {
    a <- matrix(rnorm(100000), ncol=20)
    out <- runPCA(a, rank=10)
    ref <- prcomp(a, rank.=10)

    expect_equal(out$sdev, head(ref$sdev, 10))
    expect_equal_besides_sign(out$rotation, ref$rotation)
    expect_equal_besides_sign(out$x, ref$x)

    # With scaling.
    out <- runPCA(a, rank=5, scale=TRUE)
    ref <- prcomp(a, rank.=5, scale=TRUE)

    expect_equal(out$sdev, head(ref$sdev, 5))
    expect_equal_besides_sign(out$rotation, ref$rotation)
    expect_equal_besides_sign(out$x, ref$x)

    # With scaling, but without centering.
    out <- runPCA(a, rank=5, scale=TRUE, center=FALSE)
    ref <- prcomp(a, rank.=5, scale=TRUE, center=FALSE)

    expect_equal(out$sdev, head(ref$sdev, 5))
    expect_equal_besides_sign(out$rotation, ref$rotation)
    expect_equal_besides_sign(out$x, ref$x)
})

set.seed(10001)
test_that("runPCA with approximate SVD (IRLBA) matches up to the reference implementation", {
    a <- matrix(rnorm(100000), ncol=50)
    set.seed(200)
    out <- runPCA(a, rank=10, BSPARAM=IrlbaParam(fold=Inf))
    set.seed(200)
    ref <- irlba::prcomp_irlba(a, n=10)

    expect_equal(out$sdev, ref$sdev)
    expect_equal_besides_sign(out$rotation, ref$rotation)
    expect_equal_besides_sign(out$x, ref$x)
})

set.seed(10002)
test_that("runPCA with randomized SVD matches up to the reference implementation", {
    a <- matrix(rnorm(100000), ncol=50)
    set.seed(200)
    out <- runPCA(a, rank=10, BSPARAM=RandomParam(fold=Inf))
    set.seed(200)
    ref <- rsvd::rpca(a, k=10, scale=FALSE)

    expect_equal(out$sdev, ref$sdev)
    expect_equal_besides_sign(out$rotation, ref$rotation)
    dimnames(out$x) <- NULL
    expect_equal_besides_sign(out$x, ref$x)
})

set.seed(500041)
test_that("runPCA handles named inputs", {
    y <- matrix(rnorm(10000), ncol=50)
    rownames(y) <- sprintf("THING_%i", seq_len(nrow(y)))
    colnames(y) <- sprintf("STUFF_%i", seq_len(ncol(y)))

    out <- runPCA(y, rank=5)
    expect_identical(rownames(out$x), rownames(y))
    expect_identical(rownames(out$rotation), colnames(y))
})

#' @export
#' @importFrom BiocParallel SerialParam
setGeneric("runSVD", signature=c("BSPARAM"), 
    function(x, k, nu=k, nv=k, center=FALSE, scale=FALSE, BPPARAM=SerialParam(), ..., BSPARAM=ExactParam()) 
        standardGeneric("runSVD")
)

#' @export
setGeneric("runPCA", signature=c("x"), function(x, ...) standardGeneric("runPCA"))

#' @importFrom BiocParallel SerialParam
.FUN_GENERATOR <- function(FUN, ARGS) 
# Generates the function to be used in the method,
# to avoid re-typing the whole signature.
{
    function(x, k, nu=k, nv=k, center=FALSE, scale=FALSE, BPPARAM=SerialParam(), ..., BSPARAM) {
        do.call(FUN, 
            c(
                list(x=x, k=k, nu=nu, nv=nv, center=center, scale=scale, BPPARAM=BPPARAM, ...),
                ARGS(BSPARAM)
             )
        )
    }
}

#' @export
# Uses the default ExactParam() in the generic.
setMethod("runSVD", "missing", .FUN_GENERATOR(runSVD, 
    function(BSPARAM) list(BSPARAM=BSPARAM) 
))

#' @export
setMethod("runSVD", "ExactParam", .FUN_GENERATOR(runExactSVD, 
    function(BSPARAM) list(deferred=bsdeferred(BSPARAM), fold=bsfold(BSPARAM))
))

#' @export
setMethod("runSVD", "IrlbaParam", .FUN_GENERATOR(runIrlbaSVD, 
    function(BSPARAM) {
        c(list(deferred=bsdeferred(BSPARAM), fold=bsfold(BSPARAM), extra.work=ip_extra(BSPARAM)), bsargs(BSPARAM))
    }
))

#' @export
setMethod("runSVD", "RandomParam", .FUN_GENERATOR(runRandomSVD, 
    function(BSPARAM) {            
        c(list(deferred=bsdeferred(BSPARAM), fold=bsfold(BSPARAM)), bsargs(BSPARAM))
    }
))

#' @export
#' @importFrom methods is hasMethod
#' @importClassesFrom DelayedArray DelayedMatrix
#' @importFrom DelayedArray seed
setMethod("runSVD", "FastAutoParam", function(x, k, nu=k, nv=k, center=FALSE, scale=FALSE, 
    BPPARAM=SerialParam(), ..., BSPARAM) 
{
    BSPARAMFUN <- IrlbaParam
    if (is(x, "DelayedMatrix")) {
        if (class(x)[1]=="DelayedMatrix" || !hasMethod("%*%", class(x))) { 
            BSPARAMFUN <- RandomParam
        }
    }
    runSVD(x, k=k, nu=nu, nv=nv, center=center, scale=scale, BPPARAM=BPPARAM, ...,
        BSPARAM=BSPARAMFUN(deferred=bsdeferred(BSPARAM), fold=bsfold(BSPARAM)))
})

# BiocSingular matrix class for a reconstructed low-rank matrix.
# Useful for representing the low-rank matrix without actually making it.

###################################
###################################
###################################
# Constructing the seed.

#' @export
ResidualMatrixSeed <- function(x, design=NULL) {
    .Deprecated(old="BiocSingular::ResidualMatrixSeed", new="ResidualMatrix::ResidualMatrixSeed")
    ResidualMatrix::ResidualMatrixSeed(x, design=design)
}

#' @export
#' @importFrom DelayedArray DelayedArray
ResidualMatrix <- function(x, design=NULL) {
    .Deprecated(old="BiocSingular::ResidualMatrix", new="ResidualMatrix::ResidualMatrix")
    DelayedArray(ResidualMatrix::ResidualMatrixSeed(x, design))
}

expect_equal_besides_sign <- function(left, right, ...) {
    ratio <- left/right
    right2 <- sweep(right, 2, sign(ratio[1,]), FUN="*")
    expect_equal(left, right2, ...)
}

expect_equal_svd <- function(left, right, ...) {
    expect_equal_besides_sign(left$u, right$u, ...)
    expect_equal_besides_sign(left$v, right$v, ...)
    expect_equal(left$d, right$d, ...)
}

expect_equal_product <- function(x, y) {
    expect_s4_class(x, "DelayedMatrix")
    X <- as.matrix(x)

    # standardize NULL dimnames.
    if (all(lengths(dimnames(X))==0L)) dimnames(X) <- NULL 
    if (all(lengths(dimnames(y))==0L)) dimnames(y) <- NULL 
    expect_equal(X, y)
}

# Because SnowParam() is too slow, yet MulticoreParam() fails on Windows.
# See discussion at https://github.com/Bioconductor/BiocParallel/issues/98.
safeBPParam <- function(nworkers) {
    if (.Platform$OS.type=="windows") {
        BiocParallel::SerialParam()
    } else {
        BiocParallel::MulticoreParam(nworkers)
    }
}

# Adding a test to flush out any uncontrolled parallelization.
library(BiocParallel)
failgen <- setRefClass("FailParam", 
    contains="BiocParallelParam",     
    fields=list(),
    methods=list())

FAIL <- failgen()
register(FAIL) 

library(DelayedArray)
setAutoBPPARAM(FAIL)

---
title: Matrix representations to support decomposition 
author: 
- name: Aaron Lun
  affiliation: Cancer Research UK Cambridge Institute, Cambridge, United Kingdom
date: "Revised: 26 May 2019"
output:
  BiocStyle::html_document:
    toc_float: true
package: BiocSingular 
vignette: >
  %\VignetteIndexEntry{2. Matrix classes}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}    
---

```{r, echo=FALSE, results="hide", message=FALSE}
require(knitr)
opts_chunk$set(error=FALSE, message=FALSE, warning=FALSE)
```

```{r setup, echo=FALSE, message=FALSE}
library(BiocSingular)
set.seed(100)
```

# Overview

`r Biocpkg("BiocSingular")` implements several useful `DelayedMatrix` backends for dealing with principal components analysis (PCA).
This vignette aims to provide an overview of these classes and how they can be used in other packages to improve efficiency prior to or after PCA.

# The `DeferredMatrix` class

This has now been moved to its own `r Biocpkg("ScaledMatrix")` package.
Check it out, it's pretty cool.

# The `LowRankMatrix` class

Once a PCA is performed, it is occasionally desirable to obtain a low-rank approximation of the input matrix by taking the cross-product of the rotation vectors and PC scores.
Naively doing so results in the formation of a dense matrix of the same dimensions as the input.
This may be prohibitively memory-consuming for a large data set.
Instead, we can construct a `LowRankMatrix` class that mimics the output of the cross-product without actually computing it.

```{r}
library(Matrix)
a <- rsparsematrix(10000, 1000, density=0.01)
out <- runPCA(a, rank=5, BSPARAM=IrlbaParam(deferred=TRUE)) # deferring for speed.
recon <- LowRankMatrix(out$rotation, out$x)
recon    
```

This is useful for convenient extraction of row- or column vectors without needing to manually perform a cross-product.
A `LowRankMatrix` is thus directly interoperable with downstream procedures (e.g., for visualization) that expect a matrix of the same dimensionality as the input.

```{r}
summary(recon[,1])
summary(recon[2,])
```

Again, most operations will cause the `LowRankMatrix` to collapse gracefully into `DelayedMatrix` for further processing.

# The `ResidualMatrix` class

This has now been moved to its own `r Biocpkg("ResidualMatrix")` package.
Check it out, it's pretty cool.

# Session information

```{r}
sessionInfo()
```

---
title: Matrix representations to support decomposition 
author: 
- name: Aaron Lun
  affiliation: Cancer Research UK Cambridge Institute, Cambridge, United Kingdom
date: "Revised: 26 May 2019"
output:
  BiocStyle::html_document:
    toc_float: true
package: BiocSingular 
vignette: >
  %\VignetteIndexEntry{2. Matrix classes}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}    
---

```{r, echo=FALSE, results="hide", message=FALSE}
require(knitr)
opts_chunk$set(error=FALSE, message=FALSE, warning=FALSE)
```

```{r setup, echo=FALSE, message=FALSE}
library(BiocSingular)
set.seed(100)
```

# Overview

`r Biocpkg("BiocSingular")` implements several useful `DelayedMatrix` backends for dealing with principal components analysis (PCA).
This vignette aims to provide an overview of these classes and how they can be used in other packages to improve efficiency prior to or after PCA.

# The `DeferredMatrix` class

As previously discussed, we can defer the column centering and scaling of a matrix.
The `DeferredMatrix` class provides a matrix representation that is equivalent to the output of `scale()`, but without actually performing the centering/scaling operations.
This is useful when dealing with sparse matrix representations, as naive centering would result in loss of sparsity and increased memory use.

```{r}
library(Matrix)
a <- rsparsematrix(10000, 1000, density=0.01)
object.size(a)

centering <- rnorm(ncol(a))
scaling <- runif(ncol(a))
y <- DeferredMatrix(a, centering, scaling)
y

object.size(y) # 'a' plus the size of 'centering' and 'scaling'.
```

At first glance, this seems to be nothing more than a variant on a `DelayedMatrix`.
However, the real advantage of the `DeferredMatrix` comes when performing matrix multiplication.
Multiplication is applied to the underlying sparse matrix, and the effects of centering and scaling are applied on the result.
This allows us to achieve much greater speed than `r Biocpkg("DelayedArray")`'s block-processing mechanism, 
which realizes blocks of the matrix into dense arrays prior to multiplication.

```{r}
v <- matrix(runif(ncol(a)*2), ncol=2)
system.time(X <- y %*% v)
X    
```

The cost of this speed is that the resulting matrix product is less numerically stable.
Recovering the effect of centering involves the subtraction of two (potentially large) inner products, which increases the risk of catastrophic cancellation.
Nonetheless, some reduction in accuracy may be worth the major speed-up when dense realization is avoided.

Note that it is also possible to nest `DeferredMatrix` objects within each other.
This allows users to center and scale on both dimensions, as shown below.

```{r}
centering2 <- rnorm(nrow(a))
scaling2 <- runif(nrow(a))
y2 <- DeferredMatrix(t(a), centering2, scaling2) # centering on rows of 'a'.
y3 <- DeferredMatrix(t(y2), centering, scaling) # centering on columns.
y3
```

Other operations will cause the `DeferredMatrix` to collapse gracefully into `DelayedMatrix`, leading to block processing for further calculations.

# The `LowRankMatrix` class

Once a PCA is performed, it is occasionally desirable to obtain a low-rank approximation of the input matrix by taking the cross-product of the rotation vectors and PC scores.
Naively doing so results in the formation of a dense matrix of the same dimensions as the input.
This may be prohibitively memory-consuming for a large data set.
Instead, we can construct a `LowRankMatrix` class that mimics the output of the cross-product without actually computing it.

```{r}
a <- rsparsematrix(10000, 1000, density=0.01)
out <- runPCA(a, rank=5, BSPARAM=IrlbaParam(deferred=TRUE)) # deferring for speed.
recon <- LowRankMatrix(out$rotation, out$x)
recon    
```

This is useful for convenient extraction of row- or column vectors without needing to manually perform a cross-product.
A `LowRankMatrix` is thus directly interoperable with downstream procedures (e.g., for visualization) that expect a matrix of the same dimensionality as the input.

```{r}
summary(recon[,1])
summary(recon[2,])
```

Again, most operations will cause the `LowRankMatrix` to collapse gracefully into `DelayedMatrix` for further processing.

# The `ResidualMatrix` class

This has now been moved to its own `r Biocpkg("ResidualMatrix")` package.
Check it out, it's pretty cool.

# Session information

```{r}
sessionInfo()
```

---
title: Singular value decomposition for Bioconductor packages 
author: 
- name: Aaron Lun
  affiliation: Cancer Research UK Cambridge Institute, Cambridge, United Kingdom
date: "Revised: 9 February 2019"
output:
  BiocStyle::html_document:
    toc_float: true
package: BiocSingular 
vignette: >
  %\VignetteIndexEntry{1. SVD and PCA} 
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}    
---

```{r, echo=FALSE, results="hide", message=FALSE}
require(knitr)
opts_chunk$set(error=FALSE, message=FALSE, warning=FALSE)
```

```{r setup, echo=FALSE, message=FALSE}
library(BiocSingular)
set.seed(100)
```

# Overview

The singular value decomposition (SVD) is an important procedure in general data analysis, primarily due to its use in the principal components analysis (PCA).
The `r Biocpkg("BiocSingular")` package provides methods to perform both exact and approximate SVD with a single wrapper function.
Our aim is to provide a standard framework for use in other Bioconductor packages, where users can easily switch between different SVD algorithms.
We also support parallelization throughout various parts of the SVD calculations via the `r Biocpkg("BiocParallel")` framework.

# SVD algorithm choices

To perform any SVD, we call the `runSVD()` function.
The code below performs an exact SVD to obtain the first `k` singular vectors and values (in this case, 10):

```{r}
dummy <- matrix(rnorm(10000), ncol=25)
e.out <- runSVD(dummy, k=10, BSPARAM=ExactParam())
str(e.out)
```

... but we can change the algorithm by specifying a different `BiocSingularParam` class to the `BSPARAM=` argument.
For example, we could use an approximate approach with `r CRANpkg("irlba")` instead:

```{r}
set.seed(1000)
i.out <- runSVD(dummy, k=10, BSPARAM=IrlbaParam())
```

... or we could use a randomized SVD via `r CRANpkg("rsvd")`:

```{r}
set.seed(1000)
r.out <- runSVD(dummy, k=10, BSPARAM=RandomParam())
```

By default, the exact algorithm is used when `BSPARAM=NULL`. 
The other algorithms are approximate but are much faster than the exact SVD for low `k`.
They also involve randomization, so note the use of a random seed.

# Taking the cross-product

For tall or fat matrices, it may be faster to perform the SVD on the cross-product rather than on the matrix itself.
The cross-product is usually much smaller than the original matrix and can be decomposed rapidly, with time savings offsettting the cost of the cross-product in the first place.
The results of the cross-product decomposition is used to obtain the decomposition results for the original matrix.

The definition of "tall" or "fat" is based on the fold difference in dimensions.
All `BiocSingularParam` objects have a `fold` slot that specifies the minimum fold difference between dimensions for a cross-product to be computed.
This provides an automated mechanism for deciding whether or not a cross-product should be used.

```{r}
epam <- ExactParam(fold=10)
epam
cr.out <- runSVD(dummy, k=10, BSPARAM=epam)
```

Setting `fold=1` will compute the cross-product for all matrices, even for square matrices where the gains are negligible.
Setting `fold=Inf` will never compute the cross-product for any matrix.
The default is to use `fold=5`.

# Centering and/or scaling

Centering and scaling of the input matrix can be performed with the `center=` and `scale=` arguments, respectively.
These should be numeric vectors of length equal to the number of rows of the input matrix.
The SVD will then be effectively performed on `t(t(dummy)-center)/scale)`.

```{r}
cs.out <- runSVD(dummy, k=10, scale=runif(ncol(dummy)), 
    center=rnorm(ncol(dummy)))
```

Many of the approximate algorithms (and computation of the cross-product) involve matrix multiplications.
By default, any centering and scaling is applied before any multiplication.
However, it is possible to "defer" the centering and scaling such that the multiplication can make use of features of the underlying matrix representation (e.g., sparsity).
This enables faster calculations at the expense of numerical stability.

```{r}
set.seed(2000)
def.out <- runSVD(dummy, k=10, scale=runif(ncol(dummy)), 
    center=rnorm(ncol(dummy)), BSPARAM=IrlbaParam(deferred=TRUE))
```

# Other SVD-related options

Each individual algorithm has its own parameters that may need tuning.
These can be set in the constructors for the relevant `BiocSingularParam` objects:

```{r}
ipam <- IrlbaParam(tol=1e-8, extra.work=10)
ipam
```

... which will be used in the `irlba()` function when `runSVD()` is called:

```{r}
set.seed(3000)
i.out <- runSVD(dummy, k=10, BSPARAM=ipam)
```

Internal matrix multiplications can be parallelized by setting the `BPPARAM=` argument.
This can speed up calculations when dealing with very large input matrices, e.g., from the `r Biocpkg("HDF5Array")` package.

```{r}
set.seed(4000)
library(BiocParallel)
i.out <- runSVD(dummy, k=10, BSPARAM=ipam, BPPARAM=bpparam())
```

The number of left or right singular vectors to return can be directly controlled with the `nv=` and `nu=` arguments.
This can avoid wasting time in computing these vectors when they are not required.

# Running the PCA

The main practical purpose of the SVD is to perform PCAs.
This is achieved with the `runPCA()` wrapper function, which also accepts a `BSPARAM=` argument specifying the type of algorithm to use:

```{r}
pcs.out <- runPCA(dummy, rank=10, BSPARAM=ExactParam())
str(pcs.out)
```

The output is equivalent to that of `prcomp()` - a matrix of principal component scores, the rotation vectors, and the standard deviation explained by each component.

```{r}
head(pcs.out$x)
```

Column centering is performed by default with `center=TRUE`.
Standardization of each column can be enabled with `scale=TRUE`.
Alternatively, numeric vectors can be passed to either argument for subtraction from and scaling of each column.

# Session information

```{r}
sessionInfo()
```

\name{runExactSVD}
\alias{runExactSVD}

\title{Exact SVD}
\description{Perform an exact singular value decomposition.}

\usage{
runExactSVD(x, k=min(dim(x)), nu=k, nv=k, center=FALSE, scale=FALSE, 
    deferred=FALSE, fold=Inf, BPPARAM=SerialParam())
}

\arguments{
    \item{x}{A numeric matrix-like object to use in the SVD.}
    \item{k}{Integer scalar specifying the number of singular values to return.}
    \item{nu}{Integer scalar specifying the number of left singular vectors to return.}
    \item{nv}{Integer scalar specifying the number of right singular vectors to return.}
    \item{center}{A logical scalar indicating whether columns should be centered.
        Alternatively, a numeric vector or \code{NULL} - see \code{?"\link{BiocSingular-options}"}.} 
    \item{scale}{A logical scalar indicating whether columns should be scaled. 
        Alternatively, a numeric vector or \code{NULL} - see \code{?"\link{BiocSingular-options}"}.} 
    \item{deferred}{Logical scalar indicating whether centering/scaling should be deferred, see \code{?"\link{BiocSingular-options}"}.}
    \item{fold}{Numeric scalar specifying the minimum fold difference between dimensions of \code{x} to compute the cross-product, 
        see \code{?"\link{BiocSingular-options}"}.}
    \item{BPPARAM}{A \link[BiocParallel]{BiocParallelParam} object specifying how parallelization should be performed.}
}

\details{
If any of \code{k}, \code{nu} or \code{nv} exceeds \code{min(dim(x))}, they will be capped and a warning will be raised.
The exception is when they are explicitly set to \code{Inf}, in which case all singular values/vectors of \code{x} are returned without any warning.

Note that parallelization via \code{BPPARAM} is only applied to the calculation of the cross-product.
It has no effect for near-square matrices where the SVD is computed directly.
}

\value{
A list containing:
\itemize{
    \item \code{d}, a numeric vector of the first \code{k} singular values.
    \item \code{u}, a numeric matrix with \code{nrow(x)} rows and \code{nu} columns.
    Each column contains a left singular vector.
    \item \code{u}, a numeric matrix with \code{ncol(x)} rows and \code{nv} columns.
    Each column contains a right singular vector.
}
}

\author{
Aaron Lun
}

\seealso{
\code{\link{svd}} for the underlying algorithm.
}

\examples{
a <- matrix(rnorm(100000), ncol=20)
out <- runExactSVD(a)
str(out)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/DeferredMatrix.R
\docType{class}
\name{DeferredMatrix}
\alias{DeferredMatrix}
\alias{DeferredMatrixSeed}
\title{The DeferredMatrix class}
\description{
This has been deprecated in favor of the \link[ScaledMatrix]{ScaledMatrix} class 
from the \pkg{ScaledMatrix} package - use those constructors instead.
}

\name{runPCA}
\alias{runPCA}
\alias{runPCA,ANY-method}

\title{Principal components analysis}
\description{Perform a principal components analysis (PCA) on a target matrix with a specified SVD algorithm.}

\usage{
runPCA(x, ...)

\S4method{runPCA}{ANY}(x, rank, center=TRUE, scale=FALSE, get.rotation=TRUE,
    get.pcs=TRUE, ...) 
}

\arguments{
\item{x}{A numeric matrix-like object with samples as rows and variables as columns.}
\item{rank}{Integer scalar specifying the number of principal components to retain.}
\item{center}{A logical scalar indicating whether columns of \code{x} should be centered before the PCA is performed.
Alternatively, a numeric vector of length \code{ncol(x)} containing the value to subtract from each column of \code{x}.}
\item{scale}{A logical scalar indicating whether columns of \code{x} should be scaled to unit variance before the PCA is performed.
Alternatively, a numeric vector of length \code{ncol(x)} containing the scaling factor for each column of \code{x}.}
\item{get.rotation}{A logical scalar indicating whether rotation vectors should be returned.}
\item{get.pcs}{A logical scalar indicating whether the principal component scores should be returned.}
\item{...}{
For the generic, this contains arguments to pass to methods upon dispatch.

For the \code{ANY} method, this contains further arguments to pass to \code{\link{runSVD}}.
This includes \code{BSPARAM} to specify the algorithm that should be used, and \code{BPPARAM} to control parallelization.
}
}

\details{
This function simply calls \code{\link{runSVD}} and converts the results into a format similar to that returned by \code{\link{prcomp}}.

The generic is exported to allow other packages to implement their own \code{runPCA} methods for other \code{x} objects, e.g., \pkg{scater} for SingleCellExperiment inputs.
}

\value{
A list is returned containing:
\itemize{
\item{\code{sdev}, a numeric vector of length \code{rank} containing the standard deviations of the first \code{rank} principal components.}
\item{\code{rotation}, a numeric matrix with \code{rank} columns and \code{nrow(x)} rows, containing the first \code{rank} rotation vectors.
This is only returned if \code{get.rotation=TRUE}.}
\item{\code{x}, a numeric matrix with \code{rank} columns and \code{ncol(x)} rows, containing the scores for the first \code{rank} principal components.
This is only returned if \code{get.pcs=TRUE}.}
}
}

\author{
Aaron Lun
}

\seealso{
\code{\link{runSVD}} for the underlying SVD function.

\code{?\linkS4class{BiocSingularParam}} for details on the algorithm choices.
}

\examples{
a <- matrix(rnorm(100000), ncol=20)
str(out <- runPCA(a, rank=10))
}

\name{runSVD}
\alias{runSVD}
\alias{runSVD,missing-method}
\alias{runSVD,ExactParam-method}
\alias{runSVD,IrlbaParam-method}
\alias{runSVD,RandomParam-method}
\alias{runSVD,FastAutoParam-method}
\docType{methods}

\title{Run SVD}
\description{Perform a singular value decomposition on an input matrix with a specified algorithm.}

\usage{
runSVD(x, k, nu=k, nv=k, center=FALSE, scale=FALSE, 
    BPPARAM=SerialParam(), ..., BSPARAM=ExactParam())
}

\arguments{
\item{x}{A numeric matrix-like object to use in the SVD.}
\item{k}{Integer scalar specifying the number of singular values to return.}
\item{nu}{Integer scalar specifying the number of left singular vectors to return.}
\item{nv}{Integer scalar specifying the number of right singular vectors to return.}
\item{center}{Numeric vector, logical scalar or \code{NULL}, specifying values to subtract from each column of \code{x} - see \code{?"\link{BiocSingular-options}"}.}
\item{scale}{Numeric vector, logical scalar or \code{NULL}, specifying values to divide each column of \code{x} - see \code{?"\link{BiocSingular-options}"}.}
\item{BPPARAM}{A \link[BiocParallel]{BiocParallelParam} object specifying how parallelization should be performed.}
\item{...}{Further arguments to pass to specific methods.}
\item{BSPARAM}{A \linkS4class{BiocSingularParam} object specifying the type of algorithm to run.}
}

\details{
The class of \code{BSPARAM} will determine the algorithm that is used, see \code{?\linkS4class{BiocSingularParam}} for more details.
The default is to use an exact SVD via \code{\link{runExactSVD}}.
}

\value{
A list containing:
\itemize{
\item \code{d}, a numeric vector of the first \code{k} singular values.
\item \code{u}, a numeric matrix with \code{nrow(x)} rows and \code{nu} columns.
Each column contains a left singular vector.
\item \code{v}, a numeric matrix with \code{ncol(x)} rows and \code{nv} columns.
Each column contains a right singular vector.
}
}

\author{
Aaron Lun
}

\seealso{
\code{\link{runExactSVD}}, \code{\link{runIrlbaSVD}} and \code{\link{runRandomSVD}} for the specific functions.
}

\examples{
a <- matrix(rnorm(100000), ncol=20)

out.exact0 <- runSVD(a, k=4)
str(out.exact0)

out.exact <- runSVD(a, k=4, BSPARAM=ExactParam())
str(out.exact)

out.irlba <- runSVD(a, k=4, BSPARAM=IrlbaParam())
str(out.exact)

out.random <- runSVD(a, k=4, BSPARAM=RandomParam())
str(out.random)
}

\name{runIrlbaSVD}
\alias{runIrlbaSVD}

\title{Approximate SVD with \pkg{irlba}}
\description{Perform an approximate singular value decomposition with the augmented implicitly restarted Lanczos bidiagonalization algorithm.}

\usage{
runIrlbaSVD(x, k=5, nu=k, nv=k, center=FALSE, scale=FALSE, deferred=FALSE,
    extra.work=7, ..., fold=Inf, BPPARAM=SerialParam())
}

\arguments{
    \item{x}{A numeric matrix-like object to use in the SVD.}
    \item{k}{Integer scalar specifying the number of singular values to return.}
    \item{nu}{Integer scalar specifying the number of left singular vectors to return.}
    \item{nv}{Integer scalar specifying the number of right singular vectors to return.}
    \item{center}{A logical scalar indicating whether columns should be centered.
        Alternatively, a numeric vector or \code{NULL} - see \code{?"\link{BiocSingular-options}"}.} 
    \item{scale}{A logical scalar indicating whether columns should be scaled. 
        Alternatively, a numeric vector or \code{NULL} - see \code{?"\link{BiocSingular-options}"}.} 
    \item{deferred}{Logical scalar indicating whether centering/scaling should be deferred, see \code{?"\link{BiocSingular-options}"}.}
    \item{extra.work}{Integer scalar specifying the additional number of dimensions to use for the working subspace.}
    \item{...}{Further arguments to pass to \code{\link[irlba]{irlba}}.}
    \item{fold}{Numeric scalar specifying the minimum fold difference between dimensions of \code{x} to compute the cross-product, 
        see \code{?"\link{BiocSingular-options}"}.}
    \item{BPPARAM}{A \link[BiocParallel]{BiocParallelParam} object specifying how parallelization should be performed.}
}

\details{
If \code{BPPARAM} has only 1 worker and a cross-product is not being computed, this function will use \code{\link[irlba]{irlba}}'s own \code{center} and \code{scale} arguments.
This is effectively equivalent to deferred centering and scaling, despite the setting of \code{deferred=FALSE}.

For multiple workers, this function will parallelize all multiplication operations involving \code{x} according to the supplied \code{BPPARAM}.

The total dimensionality of the working subspace is defined as the maximum of \code{k}, \code{nu} and \code{nv}, plus the \code{extra.work}.
}

\value{
A list containing:
\itemize{
    \item \code{d}, a numeric vector of the first \code{k} singular values.
    \item \code{u}, a numeric matrix with \code{nrow(x)} rows and \code{nu} columns.
    Each column contains a left singular vector.
    \item \code{u}, a numeric matrix with \code{ncol(x)} rows and \code{nv} columns.
    Each column contains a right singular vector.
}
}

\author{
Aaron Lun
}

\seealso{
\code{\link[irlba]{irlba}} for the underlying algorithm.
}

\examples{
a <- matrix(rnorm(100000), ncol=20)
out <- runIrlbaSVD(a)
str(out)
}

\name{ResidualMatrix}

\alias{ResidualMatrixSeed}
\alias{ResidualMatrix}

\docType{class}

\title{The ResidualMatrix class}
\description{
This class is deprecated, see the exact same class in the \pkg{ResidualMatrix} package.
}

\usage{
ResidualMatrixSeed(x, design=NULL)

ResidualMatrix(x, design=NULL)
}

\arguments{
\item{x}{A matrix-like object.

This can alternatively be a ResidualMatrixSeed, in which case \code{design} is ignored.}
\item{design}{A numeric matrix containing the experimental design,
to be used for linear model fitting on each \emph{column} of \code{x}.}
}

\value{
The \code{ResidualMatrixSeed} constructor will return a ResidualMatrixSeed object.

The \code{ResidualMatrix} constructor will return a ResidualMatrix object,
containing values equivalent to \code{lm.fit(x=design, y=x)$residuals}.
}

\author{
Aaron Lun
}

\name{runRandomSVD}
\alias{runRandomSVD}

\title{Approximate SVD with \pkg{rsvd}}
\description{Perform a randomized singular value decomposition.}

\usage{
runRandomSVD(x, k=5, nu=k, nv=k, center=FALSE, scale=FALSE, deferred=FALSE,
    ..., fold=Inf, BPPARAM=SerialParam())
}

\arguments{
    \item{x}{A numeric matrix-like object to use in the SVD.}
    \item{k}{Integer scalar specifying the number of singular values to return.}
    \item{nu}{Integer scalar specifying the number of left singular vectors to return.}
    \item{nv}{Integer scalar specifying the number of right singular vectors to return.}
    \item{center}{A logical scalar indicating whether columns should be centered.
        Alternatively, a numeric vector or \code{NULL} - see \code{?"\link{BiocSingular-options}"}.} 
    \item{scale}{A logical scalar indicating whether columns should be scaled. 
        Alternatively, a numeric vector or \code{NULL} - see \code{?"\link{BiocSingular-options}"}.} 
    \item{deferred}{Logical scalar indicating whether centering/scaling should be deferred, see \code{?"\link{BiocSingular-options}"}.}
    \item{...}{Further arguments to pass to \code{\link[rsvd]{rsvd}}.}
    \item{fold}{Numeric scalar specifying the minimum fold difference between dimensions of \code{x} to compute the cross-product, 
        see \code{?"\link{BiocSingular-options}"}.}
    \item{BPPARAM}{A \link[BiocParallel]{BiocParallelParam} object specifying how parallelization should be performed.}
}

\details{
All multiplication operations in \code{\link[rsvd]{rsvd}} involving \code{x} will be parallelized according to the supplied \code{BPPARAM}.

The dimensionality of the working subspace is defined as the maximum of \code{k}, \code{nu} and \code{nv}, plus the \code{q} specified in \code{...}.
}

\value{
A list containing:
\itemize{
    \item \code{d}, a numeric vector of the first \code{k} singular values.
    \item \code{u}, a numeric matrix with \code{nrow(x)} rows and \code{nu} columns.
    Each column contains a left singular vector.
    \item \code{u}, a numeric matrix with \code{ncol(x)} rows and \code{nv} columns.
    Each column contains a right singular vector.
}
}

\author{
Aaron Lun
}

\seealso{
\code{\link[rsvd]{rsvd}} for the underlying algorithm.
}

\examples{
a <- matrix(rnorm(100000), ncol=20)
out <- runRandomSVD(a)
str(out)
}

\name{LowRankMatrix}

\alias{LowRankMatrixSeed}
\alias{LowRankMatrixSeed-class}

\alias{dim,LowRankMatrixSeed-method}
\alias{dimnames,LowRankMatrixSeed-method}
\alias{extract_array,LowRankMatrixSeed-method}
\alias{DelayedArray,LowRankMatrixSeed-method}
\alias{show,LowRankMatrixSeed-method}

\alias{LowRankMatrix}
\alias{LowRankMatrix-class}

\alias{dimnames<-,LowRankMatrix,ANY-method}
\alias{t,LowRankMatrix-method}
\alias{[,LowRankMatrix,ANY,ANY,ANY-method}

\docType{class}

\title{The LowRankMatrix class}
\description{
Definitions of the LowRankMatrixSeed and LowRankMatrix classes and their associated methods.
These classes are designed to provide a memory-efficient representation of a low-rank reconstruction, e.g., after a principal components analysis.
}

\usage{
LowRankMatrixSeed(rotation, components)

LowRankMatrix(rotation, components)
}

\arguments{
\item{rotation}{A matrix-like object where each row corresponds to a row of the LowRankMatrix object.

This can alternatively be a LowRankMatrixSeed, in which case any value of \code{components} is ignored.}
\item{components}{A matrix-like object where each row corresponds to a column of the LowRankMatrix object.}
}

\value{
The \code{LowRankMatrixSeed} constructor will return a LowRankMatrixSeed object.

The \code{LowRankMatrix} constructor will return a LowRankMatrix object equivalent to \code{tcrossprod(rotation, components)}.
}

\section{Methods for LowRankMatrixSeed objects}{
LowRankMatrixSeed objects are implemented as \link[DelayedArray]{DelayedMatrix} backends.
They support standard operations like \code{dim}, \code{dimnames} and \code{extract_array}.

Passing a LowRankMatrixSeed object to the \code{\link[DelayedArray]{DelayedArray}} constructor will create a LowRankMatrix object.
}

\section{Methods for LowRankMatrix objects}{
LowRankMatrix objects are derived from \link[DelayedArray]{DelayedMatrix} objects and support all of valid operations on the latter.
Subsetting, transposition and replacement of row/column names are specialized for greater efficiency when operating on LowRankMatrix instances,
and will return a new LowRankMatrix rather than a DelayedMatrix.

All other operations applied to a LowRankMatrix will use the underlying \pkg{DelayedArray} machinery.
Unary or binary operations will generally create a new DelayedMatrix instance containing a LowRankMatrixSeed.
}

\author{
Aaron Lun
}

\examples{
a <- matrix(rnorm(100000), ncol=20)
out <- runPCA(a, rank=10)

lr <- LowRankMatrix(out$rotation, out$x)
}

\seealso{
\code{\link{runPCA}} to generate the rotation and component matrices.
}

\name{BiocSingularParam}
\alias{BiocSingularParam-class}

\alias{ExactParam}
\alias{ExactParam-class}

\alias{IrlbaParam}
\alias{IrlbaParam-class}
\alias{show,IrlbaParam-method}

\alias{RandomParam}
\alias{RandomParam-class}
\alias{show,RandomParam-method}

\alias{FastAutoParam}
\alias{FastAutoParam-class}

\docType{class}
\alias{show,BiocSingularParam-method}

\alias{bsfold}
\alias{bsdeferred}
\alias{bsparam}

\title{BiocSingularParam classes}
\description{Classes for specifying the type of singular value decomposition (SVD) algorithm and associated parameters.}

\usage{
ExactParam(deferred=FALSE, fold=Inf)

IrlbaParam(deferred=FALSE, fold=Inf, extra.work=7, ...)

RandomParam(deferred=FALSE, fold=Inf, ...)

FastAutoParam(deferred=FALSE, fold=Inf)

bsparam()
}

\arguments{
    \item{deferred}{Logical scalar indicating whether centering/scaling should be deferred, see \code{?"\link{BiocSingular-options}"}.}
    \item{fold}{Numeric scalar specifying the minimum fold-difference for cross-product calculation, see \code{?"\link{BiocSingular-options}"}.}
    \item{extra.work}{Integer scalar, additional dimensionality of the workspace in \code{\link{runIrlbaSVD}}.}
    \item{...}{Additional arguments to pass to \code{\link{runIrlbaSVD}} or \code{\link{runRandomSVD}}.
    This should not include any named arguments in those functions.}
}

\details{
The BiocSingularParam class controls dispatch of the \code{\link{runSVD}} generic to specific algorithms for SVD.
The BiocSingularParam class itself is virtual, with several concrete subclasses available in this package:
\describe{
    \item{\code{ExactParam}:}{exact SVD with \code{\link{runExactSVD}}.}
    \item{\code{IrlbaParam}:}{approximate SVD with \pkg{irlba} via \code{\link{runIrlbaSVD}}.}
    \item{\code{RandomParam}:}{approximate SVD with \pkg{rsvd} via \code{\link{runRandomSVD}}.}
    \item{\code{FastAutoParam}:}{fast approximate SVD, chosen based on the matrix representation.}
}
These objects also hold parameters specifying how each algorithm should be run on an arbitrary data set.
See the associated documentation pages for each specific SVD method for more details.
}

\section{Methods}{
In the following code snippets, \code{x} is a BiocSingularParam object.
\describe{
\item{\code{show(object)}:}{Display the class of \code{object} and a summary of the set parameters.}
\item{\code{bsfold(object)}:}{Return a numeric scalar specifying the fold-difference for cross-product calculation,
see \dQuote{Computing the cross-product} in \code{?"\link{BiocSingular-options}"}.}
\item{\code{bsdeferred(object)}:}{Return a logical scalar indicating whether centering and scaling should be deferred.
see \dQuote{Deferred centering and scaling} in \code{?"\link{BiocSingular-options}"}.}
}
}

\section{Automatically choosing a fast SVD algorithm}{
Running \code{\link{runSVD}} with a FastAutoParam object will dispatch to \code{\link{runIrlbaSVD}} for most matrices.
This is the default choice as IRLBA is fast and the approximation is highly similar to the exact SVD result. 
The exception is that of instances of the \link[DelayedArray]{DelayedMatrix} class, or any subclass that lacks its own specialized \code{\%*\%} method.
In such cases, \code{\link{runSVD}} with a FastAutoParam will dispatch to \code{\link{runRandomSVD}}, which minimizes the number of matrix multiplication steps and the associated costly block processing.
However, if a DelayedMatrix subclass has its own \code{\%*\%} method, it is assumed to be efficient enough to afford repeated multiplications in \code{\link{runIrlbaSVD}}.
}

\section{Setting a session-wide default}{
\code{bsparam()} will return a session-wide value for the BiocSingularParam object, analogous to \code{\link[BiocParallel]{bpparam}()}.
This defaults to a FastAutoParam object but can be modified by setting the \code{"BiocSingularParam.default"} global option to any BiocSingularParam object.
Any code that uses \code{bsparam()} will automatically use this new default without needing to explicitly pass the BiocSingularParam object to those functions.
}

\value{
Each constructor returns a BiocSingularParam subclass of the same type, containing the specified parameters.
}

\seealso{
\code{\link{runSVD}} for generic dispatch.

\code{\link{runExactSVD}}, \code{\link{runIrlbaSVD}} and \code{\link{runRandomSVD}} for specific methods.
}

\author{
Aaron Lun
}

\examples{
ExactParam()

IrlbaParam(tol=1e-8)

RandomParam(q=20)

# Modifying the default.
bsparam()
options(BiocSingularParam.default=IrlbaParam())
bsparam()
}

\name{BiocSingular options}
\alias{BiocSingular-options}

\title{Global SVD options}
\description{An overview of the available options when performing SVD with any algorithm.}

\section{Computing the cross-product}{ 
If the dimensions of the input matrix are very different, it may be faster to compute the cross-product and perform the SVD on the resulting square matrix,
rather than performing SVD directly on a very fat or tall input matrix.
The cross-product can often be computed very quickly due to good data locality, yielding a small square matrix that is easily handled by any SVD algorithm.
This is especially true in cases where the input matrix is not held in memory.
Calculation of the cross-product only involves one read across the entire data set, 
while direct application of approximate methods like \code{\link[irlba]{irlba}} or \code{\link[rsvd]{rsvd}} would need to access the data multiple times.

The various \pkg{BiocSingular} SVD functions allow users to specify the minimum fold difference (via the \code{fold} argument) at which a cross-product should be computed. 
Setting \code{fold=1} will always compute the cross-product for any matrix - this is probably unwise. 
By contrast, setting \code{fold=Inf} means that the cross-product is never computed.
This is currently the default in all functions, to provide the most expected behaviour unless specifically instructed otherwise.
}

\section{Centering and scaling}{
In general, each SVD function performs the SVD on \code{t((t(x) - C)/S)} where \code{C} and \code{S} are numeric vectors of length equal to \code{ncol(x)}.
The values of \code{C} and \code{S} are defined according to the \code{center} and \code{scale} options.
\itemize{
    \item If \code{center=TRUE}, \code{C} is defined as the column means of \code{x}.
        If \code{center=NULL} or \code{FALSE}, all elements of \code{C} are set to zero.
        If \code{center} is a numeric vector with length equal to \code{ncol(x)}, it is used to directly define \code{C}.
    \item If \code{scale=TRUE}, the \code{i}th element of \code{S} is defined as the square root of \code{sum((x[,i] - C[i])^2)/(ncol(x)-1)}, for whatever \code{C} was defined above.
        This mimics the behaviour of \code{\link{scale}}.
        If \code{scale=NULL} or \code{FALSE}, all elements of \code{S} are set to unity.
        If \code{scale} is a numeric vector with length equal to \code{ncol(x)}, it is used to directly define \code{S}.
}

Setting \code{center} or \code{scale} is more memory-efficient than modifiying the input \code{x} directly.
This is because the function will avoid constructing intermediate centered (possibly non-sparse) matrices.
}

\section{Deferred centering and scaling}{
Many of the SVD algorithms (and computation of the cross-product) involve repeated matrix multiplications.
We speed this up by using the \link[ScaledMatrix]{ScaledMatrix} class to defer centering (and to some extent, scaling) during matrix multiplication.
The matrix multiplication is performed on the original matrix, and then the centering/scaling operations are applied to the matrix product.
This allows direct use of the \code{\%*\%} method for each matrix representation, to exploit features of the underlying representation (e.g., sparsity) for greater speed.

Unfortunately, the speed-up with deferred centering comes at the cost of increasing the risk of catastrophic cancellation.
The procedure requires subtraction of one large intermediate number from another to obtain the values of the final matrix product.
This could result in a loss of numerical precision that compromises the accuracy of the various SVD algorithms. 

The default approach is to explicitly create a dense in-memory centred/scaled matrix,
possibly via block processing (see \code{\link[DelayedArray]{defaultAutoGrid}} from the \pkg{DelayedArray} package).
This avoids problems with numerical precision as large intermediate values are not formed.
In doing so, we consistently favour accuracy over speed unless the functions are specifically instructed to do otherwise, i.e., with \code{deferred=TRUE}.
}

\author{
Aaron Lun
}
